package org.json;

public class JSONKey {

	private Object key;
	private int line;
	private int start,end;
	
	private JSONObject parent;
	
	public JSONKey( JSONObject parent, Object key, JSONTokener lexer ) {
		this.parent = parent;
		this.key = key;
		if ( lexer != null ) {
			this.line = ( int )lexer.getLine();
			this.start = lexer.getStartIndex() - 1;
			this.end = lexer.getEndIndex();
		}
	}
	
	public JSONKey( String key, JSONTokener lexer ) {
		this( null, key, lexer );
	}
	
	public String getKey() {
		return this.key.toString();
	}
	
	public boolean isBoolean() { return this.key instanceof Boolean; }
	public boolean isInteger() { return this.key instanceof Integer; }
	public boolean isString() { return this.key instanceof String; }
	
	public JSONObject getParent() {
		return parent;
	}
	
	public int getLine() {
		return this.line;
	}
	
	public int getStart() {
		return start;
	}
	
	public int getEnd() {
		return end;
	}
	
	private JSONKey value;
	
	public JSONKey getValue() {
		return value;
	}
	
	public void setValue( JSONKey value ) {
		this.value = value;
	}
	
	@Override
	public boolean equals(Object obj) {
		if ( key.toString().equalsIgnoreCase( obj.toString() ) )
			return true;
		return super.equals( obj );
	}
	
}
