package com.japisoft.datasource.filesystem;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import com.japisoft.datasource.DataSourceItem;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FileSystemDataSourceItem 
	extends FileSystemDataSource 
		implements DataSourceItem {

	public FileSystemDataSourceItem( File f ) {
		super( f );
	}

	public void delete() {
		f.delete();
	}

	public byte[] getContent() throws Exception {
		FileInputStream fin = new FileInputStream( f );
		try {
			byte[] data = new byte[ (int)f.length() ];
			fin.read( data );
			return data;
		} finally {
			fin.close();
		}		
	}

	public void setContent( byte[] content ) throws Exception {
		FileOutputStream fout = new FileOutputStream( f );
		try {
			fout.write( content );
		} finally {
			fout.close();
		}
	}

}
