package com.japisoft.datasource.ftp;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.commons.vfs.FileContent;
import org.apache.commons.vfs.FileObject;
import org.apache.commons.vfs.FileSystemException;

import com.japisoft.datasource.DataSourceItem;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FTPDataSourceItem extends FTPDataSource implements DataSourceItem {

	public FTPDataSourceItem( FileObject fo ) {
		super( fo );
	}

	public void delete() {
		try {
			fo.delete();
		} catch( FileSystemException fse ) {
			
		}
	}

	public byte[] getContent() throws Exception {
		FileContent fc = fo.getContent();
		InputStream in = fc.getInputStream();
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		byte[] buffer = new byte[ 1024 ];
		int c;
		while ( ( c = in.read( buffer ) ) > -1 ) {
			bout.write( buffer, 0, c );
		}
		return bout.toByteArray();
	}

	public void setContent(byte[] content) throws Exception {
		FileContent fc = fo.getContent();
		OutputStream out = fc.getOutputStream();
		out.write( content );
	}
	

	
}
