package com.japisoft.dtdparser;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class ParserElement {
	/** Stop location */
	public int stop = -1;
	/** Character sopping the element */
	public char token = 0;
	public char occ = 0;
	public String content = null;
	public boolean literal = false;

	public ParserElement() {
	}

	public boolean hasToken() {
		return token != 0;
	}

	public static boolean isLiteral(char ch) {
		return ch == '\'' || ch == '"';
	}

	public boolean isWord() {
		return (content != null);
	}

	public static boolean isOperator(char ch) {
		return ch == '?' || ch == '*' || ch == '+';
	}

	public static boolean isToken(char ch) {
		return ch == '('
			|| ch == ')'
			|| ch == ','
			|| ch == '|'
			|| ch == '>'
			|| ch == '%'
			|| ch == ';'
			|| isOperator(ch);
	}

}

// ParserElement ends here
