package com.japisoft.dtdparser;

import java.io.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface XMLGenerator {

    // Encoding type

    public static String ENCODING_UTF_8="UTF-8";
    public static String ENCODING_UTF_16="UTF-16";
    public static String ENCODING_ISO_10646_UCS_2="ISO-10646-UCS-2";
    public static String ENCODING_ISO_10646_UCS_4="ISO-10646-UCS-4";
    public static String ENCODING_ISO_8859_1="ISO-8859-1";
    public static String ENCODING_ISO_8859_2="ISO-8859-2";
    public static String ENCODING_ISO_8859_3="ISO-8859-3";
    public static String ENCODING_ISO_8859_4="ISO-8859-4";
    public static String ENCODING_ISO_8859_5="ISO-8859-5";
    public static String ENCODING_ISO_8859_6="ISO-8859-6";
    public static String ENCODING_ISO_8859_7="ISO-8859-7";
    public static String ENCODING_ISO_8859_8="ISO-8859-8";
    public static String ENCODING_ISO_8859_9="ISO-8859-9";
    public static String ENCODING_ISO_2022_JP="ISO-2022-JP";
    public static String ENCODING_Shift_JIS="Shift_JIS";
    public static String ENCODING_EUC_JP="EUC-JP";

    /** Generate a minimal valid XML document. You may insert an encoding using the <code>ENCODING_...</code> constants
	@param output final document target
	@param encoding use <code>ENCODING..<code> constants
	@param root the root node for the generation
	@param dtdURI dtd location */
    public void writeDocument( PrintWriter output, String encoding, String root, String dtdURI ) throws IOException;

    /** Generate a minimal valid XML document. 
	@param output final document target
	@param root the root node for the generation
	@param dtdURI dtd location */
    public void writeDocument( PrintWriter output, String root, String dtdURI ) throws IOException;

}

// XMLGenerator ends here
