package com.japisoft.dtdparser.document;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TraceDTDDocumentBuilder extends AbstractDTDDocumentBuilder {
	public TraceDTDDocumentBuilder() {
		super();
	}

	/** Start the DTD definition */
	public void notifyStartDTD() {
		System.out.println("* start the DTD");
	}

	/** Stop the DTD definition */
	public void notifyStopDTD() {
		System.out.println("* stop the DTD");
	}

	public void notifyComment(String comment) {
		System.out.println("* comment :" + comment);
	}

	public void notifyEntity(String entity, boolean reference, int type,
			String value) {
		System.out.println("* entity : [" + entity + "] = [" + value + "]");
	}

	public void notifyStartElement(String e) {
		System.out.println("* start element [" + e + "]");
	}

	public void notifyStopElement() {
		System.out.println("* stop element");
	}

	/** Item equals element name or #PCDATA */
	public void notifyElementChoiceItem(String item) {
		System.out.println("* item choice element [" + item + "]");
	}

	/** Item equals element name or EMPTY or ANY or #PCDATA */
	public void notifyElementIncludeItem(String item) {
		System.out.println("* item include element [" + item + "]");
	}

	/** Notify '(' meet for the element declaration */
	public void notifyStartElementChildren() {
		System.out.println("* notify start element children");
	}

	/** Notify operator '+' or '*' or '?' */
	public void notifyOperator(char operator) {
		System.out.println("* notify operator : " + operator);
	}

	/** Notify ')' meet for the element declaration */
	public void notifyStopElementChildren() {
		System.out.println("* notify stop element children");
	}

	/**
	 * @param element
	 *            Element tag
	 * @param id
	 *            Attribute id
	 * @param valueType
	 *            ID, IDREF, ENTITY, ENTITIES, NMTOKEN, NMTOKENS or CDATA
	 * @param enum
	 *            a <code>String[]</code> value
	 * @param attDec
	 *            REQUIRED, IMPLIED or FIXED
	 * @param def
	 *            a <code>String</code> value or ""
	 */
	public void notifyAttribute(String element, String id, int valueType,
			String[] enume, int attDec, String def) {
		System.out.println(" notify attribute [" + id + "] for [" + element
				+ "] /" + valueType + "/" + enume.length + "/" + attDec + " ["
				+ def + "]");
	}

	public String getFirstElement() {
		return null;
	}

}

// DTDDocumentBuilder ends here

