package com.japisoft.editix.action.docbook;

import java.awt.Dimension;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.List;
import java.util.Set;
import java.util.Map.Entry;

import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

import com.japisoft.editix.ui.EditixDialog;
import com.japisoft.framework.ui.text.FileTextField;
import com.japisoft.xmlpad.XMLContainer;


/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DocBookDialog extends EditixDialog {

	private DocBookDialogPanel panel = null;
	
	public DocBookDialog() {
		super(
			"DocBook",
			"DocBook usage",
			"Transform your DocBook document to multiple outputs.Note that this is only for \"book\" document. Choose an output file. Store these parameters using a project for the next time." );
		panel = new DocBookDialogPanel();
		add( panel );
	}

	
	protected Dimension getDefaultSize() {
		return new Dimension( 350, 250 );
	}
	
	public void init( XMLContainer container ) {
		panel.init( container );
	}
	
	public void store( XMLContainer container ) {	
		panel.store( container );
	}

}	
