package com.japisoft.editix.action.docbook;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Set;
import java.util.Map.Entry;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ParametersModel {

	private HashMap parameters;
	private HashMap helps;
	// private HashMap<String,Integer> location;
	// private int lineCounter = 0;
	
	public void read() {
		parameters = new HashMap();
		helps = new HashMap();
		// location = new HashMap<String,Integer>();
		values = new HashMap();
		
		URL location = getClass().getResource( 
				"parameters.txt" );
		if ( location == null ) {
			System.err.println( 
				"Can't find parameters.txt for docbook" );
		} else {
			try {
				BufferedReader br =
					new BufferedReader(
							new InputStreamReader(
									location.openStream() ) );
				try {
					
					String l = null;
					while ( ( l = br.readLine() ) != null ) {
						if ( l.startsWith( "-" ) )
							setCurrentType( l );
						else
							addParameter( l );
					}
					
				} finally {
					br.close();
				}
			} catch (IOException e) {
				
			}
		}
	}
	
	private String currentType = null;
	
	private void setCurrentType( String type ) {
		int i = type.lastIndexOf( "." ) + 1;
		if ( i > 0 )
			currentType = type.substring( i );
		else
			currentType = "NoCategory";
	}
	
	private void addParameter( String parameter ) {
		if ( currentType == null )
			return;	// ?
		
		// lineCounter++;		
		// location.put( parameter , lineCounter );

		String[] res = parameter.split( "" );
		if ( res != null && res.length == 2 ) {
			String param = res[ 0 ].trim();
			String help = res[ 1 ].trim();
			List ls = 
				( List )parameters.get( currentType );
			if ( ls == null )
				parameters.put( currentType, ls = new ArrayList() );
			ls.add( param );
			helps.put( param, help );
		}
	}
	
	public List getTypes() {
		ArrayList tmp = new ArrayList( parameters.keySet() );
		Collections.sort( tmp );
		return tmp;
	}
	
	public List getParameters( String type ) {
		return ( List )parameters.get( type );
	}
	
	public String getHelp( String parameter ) {
		return ( String )helps.get( parameter );
	}

	//public int getParameterLocation( String parameter ) {
	//	return location.get( parameter );
	//}
	
	private HashMap values = null;
	
	public void setValue( String parameter, String value ) {
		if ( parameter != null ) {
			if ( value == null )
				values.remove( parameter );
			else
				values.put( parameter, value );
		}
	}

	public String getValue( String parameter ) {
		return ( String )values.get( parameter );
	}

	public Set getValues() {
		return ( Set )values.entrySet();
	}

}
