package com.japisoft.editix.action.file;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Properties;

import com.japisoft.editix.action.panels.PanelAction;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.ui.panels.universalbrowser.FTPChooserPanel;
import com.japisoft.editix.ui.panels.universalbrowser.FTPConfig;
import com.japisoft.editix.ui.panels.universalbrowser.CommonUniversalBrowserPanel;
import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.dialog.DialogManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BrowseFTPAction extends PanelAction {
	
	public void actionPerformed(ActionEvent e) {
		
		FTPChooserPanel panel = new FTPChooserPanel();
		panel.setPreferredSize( new Dimension( 300, 300 ) );
		
 		Properties prop = new Properties();
		File workingPath = ApplicationModel.getAppUserPath();
		File fConfig = new File( workingPath, "ftp.cfg" );

		if ( fConfig.exists() ) {
			try {
				prop.load( new FileInputStream( fConfig ) );
			} catch (FileNotFoundException e1) {
			} catch (IOException e1) {
			}
			Enumeration keys = prop.keys();
			ArrayList al = new ArrayList();
			while ( keys.hasMoreElements() ) {
				String key = ( String )keys.nextElement();
				String val = prop.getProperty( key );
				int i = key.indexOf( "-" );
				FTPConfig config = new FTPConfig();
				config.host = key.substring( 0, i );
				config.user = key.substring( i + 1 );
				i = val.indexOf( "-" );
				config.directory = val.substring( 0, i );
				config.password = val.substring( i + 1 );
				al.add( config );
			}
			panel.restoreSaveHosts( al );
		}

		if ( DialogManager.showDialog(
				EditixFrame.THIS,
				"FTP host",
				"FTP host",
				"Define your FTP access",
				null,
				panel ) ==
					DialogManager.OK_ID ) {

			FTPConfig config = panel.getFTPConfig();
			
			if ( config.directory != null ) {
				if ( !config.directory.startsWith( "/" ))
					config.directory = "/" + config.directory;
			} else
				config.directory = "/";

			//ftp://myusername:mypassword@somehost

			String uri = 
				"ftp://" + config.host + config.directory;

				
			( ( CommonUniversalBrowserPanel )( preparePanel() ) ).browse(
					uri, config.user, config.password );
			
			if ( config.save ) {
				prop.put( config.host + "-" + config.user, config.directory + "-" + config.password );
				try {
					prop.save( new FileOutputStream( fConfig ), null );
				} catch (FileNotFoundException e1) {
				}
			}
			
			alwaysShown = true;

			super.actionPerformed(e);
			
		}

	}

}
