package com.japisoft.editix.action.file;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Map;
import java.util.Set;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JMenu;

import com.japisoft.editix.action.file.PinManager.FileInfo;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.application.descriptor.InterfaceBuilder;
import com.japisoft.framework.application.descriptor.helpers.MenuBuilderDelegate;
import com.japisoft.xflows.task.ui.MenuBuilder;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class PinFilesMenuBuilder implements MenuBuilderDelegate {

	@Override	
	public void build( JMenu menu ) {
		menu.removeAll();
		try {
			for ( int i = 0; i < PinManager.Instance().getItemCount(); i++ ) {
				menu.add( new PinFileAction( PinManager.Instance().getItem( i ) ) );
			}
			menu.setEnabled( PinManager.Instance().getItemCount() > 0 );			
		} catch ( Throwable e ) {
		}		
	}

	class PinFileAction extends AbstractAction {
		private FileInfo fi = null;
		public PinFileAction( FileInfo fi ) {
			putValue( Action.NAME, fi.location );
			this.fi = fi;
		}
		public void actionPerformed( ActionEvent e ) {
			String location = ( String )getValue( Action.NAME );
			File f = new File( location );
			if ( !f.exists() ) {
				EditixFactory.buildAndShowErrorDialog( "Can't load " + location );
				PinManager.Instance().removeFile( location );
			} else {	
				Map<String,String> properties = fi.properties;
				String flatProperties = "";
				Set<String> keys = properties.keySet();
				for ( String k : keys ) {
					if ( !"".equals( flatProperties ) )
						flatProperties += ";";
					flatProperties += k + "=" + properties.get( k );
				}
				OpenAction.openFile( fi.type, false, location, null, flatProperties );
			}
		}
	}
	
}
