package com.japisoft.editix.action.file;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import com.japisoft.framework.application.descriptor.ActionModel;
import com.japisoft.editix.project.ProjectManager;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixStatusBar;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SaveProjectAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {

		if ( ProjectManager.getLastOpenProject( false ) == null && 
				getValue( "param" ) == null )
			ActionModel.activeActionById( ActionModel.SAVEAS_PROJECT, e );
		else {
			String file = ProjectManager.getLastOpenProject( false );
			if ( getValue( "param" ) != null ) 
				file = getValue( "param" ).toString();

			ActionModel.activeActionById( ActionModel.SAVE_ALL, e );

			/*// Update the ProjectModel model
			 ProjectManager.cleanProjectContent();
			 for ( int i = 0; i < EditixFrame.ACCESSOR.getMainTabbedPane().getTabCount() ; i++ ) {
				XMLContainer container = ( XMLContainer ) 
					( ( IXMLPanel )EditixFrame.ACCESSOR.getMainTabbedPane().getComponentAt( i ) ).getMainContainer();
				if ( container == null )
					continue;
				if ( container.getCurrentDocumentLocation() != null && container.getCurrentDocumentLocationArg() == null ) {
					ProjectManager.addProjectElement( container );
				}
			}*/ 

			if ( file.indexOf( ".") == -1 )
				file += ".pre";
			
			if ( ProjectManager.isEmpty() ) {
				EditixFactory.buildAndShowWarningDialog( "Your project is empty. Can't save" );
			} else  {
			
				boolean ok = ProjectManager.saveProject( file );
			
				if ( !ok ) {
					EditixFactory.buildAndShowErrorDialog( "Can't save this project " + ProjectManager.getLastOpenProject( false ) );
				} else {
					OpenProjectAction.updateOpenRecent( file );
					EditixStatusBar.ACCESSOR.setDelayedMessage( "File " + file + " saved..." );
				}
			
			}
		}
	}
	
}
