package com.japisoft.editix.action.fop;

import java.awt.Dimension;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.wizard.WizardContext;
import com.japisoft.editix.wizard.WizardContextFactory;
import com.japisoft.editix.wizard.list.ListWizard;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FOListAction extends AbstractAction {

	public void actionPerformed(ActionEvent e) {
		ListWizard tw = new ListWizard();
		tw.setContext( getContext() );
		if ( DialogManager.showDialog( 
				EditixFrame.THIS, 
				"New List", 
				"Create a new list of items", 
				"Generate a new list at the current location. Double click on items for changing the label", 
				null, 
				tw, new Dimension( 250, 400 ) ) == DialogManager.OK_ID ) {
			FPNode node = tw.getResult();
			EditixFrame.THIS.getSelectedContainer().insertText( node.getRawXML( 1 ) );
		}
	}

	protected WizardContext getContext() {
		return WizardContextFactory.getInstance().getContext( "FO" );
	}

}
