package com.japisoft.editix.action.options;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.xml.transform.TransformerFactory;

import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.xml.XMLConfigPanel;
import com.japisoft.framework.xml.XSLTTransformer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ChooseTransformerAction extends AbstractAction {

	public void actionPerformed(ActionEvent e) {
		XMLConfigPanel panel = null;
		if ( DialogManager.showDialog(
				EditixFrame.THIS,
				"JAXP Transformer",
				"Install a JAXP Compatible transformer",
				"Add your java jars and select a java JAXP compatible class for changing the EditiX XSLT Transformer",
				null,
				panel = new XMLConfigPanel( 
						TransformerFactory.class,
						XSLTTransformer.CONFIG_FILE ), new Dimension( 400, 500 ) ) == 
								DialogManager.OK_ID ) {
			if ( panel.save() ) {
				EditixFactory.buildAndShowInformationDialog( "Restart EditiX for using the new transformer" );
			}
		}
		
	}

}
