package com.japisoft.editix.action.search.file;

import java.io.File;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SearchResultImpl implements SearchResult {

	private String res = null;
	private int line = -1;
	private File source = null;
	
	public SearchResultImpl( String res, int line ) {
		this.res = res;
		this.line = line;
		checkRes();
	}
	
	private int nbResult = -1;

	public SearchResultImpl( File source, int nbResult ) {
		this.res = source.getName();
		this.source = source;
		this.nbResult = nbResult;
		checkRes();
	}
		
	public File getSource() {
		return source;
	}
	
	public int getLine() {
		return line;
	}

	private String type = null;
	
	public String getType() {
		if ( source == null )
			return null;
		if ( type == null ) {
			type = source.toString();
			int i = type.lastIndexOf( "." );
			if ( i > -1 ) {
				type = type.substring( i + 1 ).toLowerCase();
			} else
				type = "xml";
		}
		return type;
	}

	private void checkRes() {
		if ( res.length() > 20 ) {
			res = res.substring( 0, 20 ) + "...";
		}
		res = res.trim();
		if ( nbResult > 0 )
			res += " (" + nbResult + " matching)";		
	}
	
	public String toString() {
		return res;
	}

}
