package com.japisoft.editix.action.search.file;

import java.io.BufferedReader;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

import com.japisoft.editix.toolkit.Toolkit;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TextSearchEngineImpl implements SearchEngine {

	public List search( File f, String item ) {
		try {
			BufferedReader br = new BufferedReader( 
					Toolkit.getReaderForFile( 
							f ) );
			try {
				String l = null;
				item = item.toLowerCase();
				ArrayList res = null;
				int cpt = 0;
				while ( ( l = br.readLine() ) != null ) {
					if ( l.toLowerCase().contains( item ) ) {
						if ( res == null )
							res = new ArrayList();
						res.add( new SearchResultImpl( l, cpt ) );
					}
					cpt++;
				}
				return res;
			} finally {
				br.close();
			}
		} catch (Exception e) {
			return null;
		}

	}

	public String toString() {
		return "Text";
	}

}
