package com.japisoft.editix.action.template;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.JComboBox;
import javax.swing.JPanel;

import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.xmlpad.action.toolkit.InsertAction;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class InsertParamAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {
		
		JPanel panel = new JPanel(); 
		JComboBox cb = new JComboBox(
				ParamModel.DEFAULT );
		cb.setEditable( false );
		panel.add( cb );

		if ( DialogManager.showDialog(
				EditixFrame.THIS,
				"Template Param",
				"Choose a template param",
				"Choose a template param. It will be used when creating a new document. Go to the preferences for setting the default values",
				null,
				panel,
				new Dimension( 300, 200 )
				 ) == DialogManager.OK_ID ) {
			InsertAction a = new InsertAction( "${" + ( String )cb.getSelectedItem() + "}" );
			a.setXMLContainer( EditixFrame.THIS.getSelectedContainer() );
			try {
				a.notifyAction();
			} finally {
				a.setXMLContainer( null );
			}
		}
	}	

}
