package com.japisoft.editix.action.tree;

import java.awt.Color;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JColorChooser;
import javax.swing.JTree;
import javax.swing.tree.TreePath;

import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ColorAction extends AbstractAction {
	
	public void actionPerformed(ActionEvent e) {

		XMLContainer container = 
			EditixFrame.THIS.getSelectedContainer();
		if ( container != null ) {
			JTree t = container.getTree();
			TreePath tp = t.getSelectionPath();
			if ( tp != null ) {
				FPNode sn = ( FPNode )tp.getLastPathComponent();
				if ( sn.isTag() ) {
					JColorChooser jc = new JColorChooser();
					String color = ( String )container.getProperty( "color." + sn.getContent() );
					Color initialColor = null;
					if ( color != null ) {
						initialColor = new Color( Integer.parseInt( color, 16 ) );
					}
					Color c = jc.showDialog( t, "Color a node", initialColor );
					if ( c != null ) {
						container.setProperty( "color." + sn.getContent(), Integer.toHexString( c.getRGB() ).substring( 2 ) );
						container.getTree().repaint();
						container.getEditor().repaint();
					}
				} else {
					EditixFactory.buildAndShowWarningDialog( "Please choose a node" );
				}
			}
		}
		
	}

}
