package com.japisoft.editix.action.view;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;

import org.apache.batik.swing.JSVGCanvas;
import org.apache.batik.swing.svg.JSVGComponent;

import com.japisoft.framework.application.descriptor.ActionModel;
import com.japisoft.editix.ui.EditixDialog;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SVGView extends AbstractAction {

	public void actionPerformed(ActionEvent e) {
		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if ( container == null )
			return;
		if ( EditixFactory.mustSaveDialog( container ) ) {
			return;
		}
		ActionModel.activeActionById( ActionModel.SAVE, e );
		if ( !ActionModel.LAST_ACTION_STATE )
			return;
		SVGDialog dialog = new SVGDialog(
			container.getDocumentInfo().getCurrentDocumentLocation() );
		dialog.setVisible( true );
		dialog.dispose();
	}

	class SVGDialog extends EditixDialog {
		SVGDialog( String svg ) {
			super( "SVG", "SVG View", "This is a SVG preview. Please wait a little delay for final rendering" );
			//JSVGComponent view = new JSVGComponent();
			JSVGCanvas view = new JSVGCanvas();
			getContentPane().add( view );
			view.loadSVGDocument( new File( svg ).toURI().toString() );
		}
		protected Dimension getDefaultSize() {
			return new Dimension( 400, 400 );
		}
		
	}

}
