package com.japisoft.editix.action.xml.update;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.SwingUtilities;

import com.japisoft.editix.action.file.NewAction;
import com.japisoft.editix.document.DocumentModel;
import com.japisoft.editix.document.TemplateModel;
import com.japisoft.editix.editor.jsx.JSXContainer;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.ui.xslt.XSLTEditor;
import com.japisoft.framework.application.descriptor.ActionModel;
import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.XMLDocumentInfo;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class UpdateWithXSLT2 extends AbstractAction {

	@Override
	public void actionPerformed(ActionEvent e) {
		if ( EditixFrame.THIS.getSelectedContainer() == null ) {
			EditixFactory.buildAndShowErrorDialog( "Need a valid XML document ?" );
			return;
		}
		if ( EditixFrame.THIS.getSelectedContainer().getCurrentDocumentLocation() == null ) {
			EditixFactory.buildAndShowErrorDialog( "You must save your document before transforming" );
			return;
		}
		
		ActionModel.activeActionById( ActionModel.SAVE, e );
		
		String xmlPath = EditixFrame.THIS.getSelectedContainer().getCurrentDocumentLocation();
		
		NewAction na = new NewAction();
		na.setTemplate( TemplateModel.getTemplateByLabel( "XSLT 2.0/XML" ) );
		na.actionPerformed( e );
		
		SwingUtilities.invokeLater(
				new Runnable() {
					@Override
					public void run() {
						IXMLPanel panel = EditixFrame.THIS.getSelectedPanel();
						panel.setProperty( XSLTEditor.XSLT_DATA_FILE_KEY, xmlPath );
						panel.setProperty( XSLTEditor.XSLT_RESULT_FILE_KEY, xmlPath );					
					}
				} );		
	}

}
