package com.japisoft.editix.editor.js.helper;

import java.util.Arrays;
import java.util.List;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.text.BadLocationException;
import javax.swing.text.Element;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.editor.XMLPadDocument;
import com.japisoft.xmlpad.helper.handler.AbstractHelperHandler;
import com.japisoft.xmlpad.helper.model.BasicDescriptor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ParametersHandler extends AbstractHelperHandler {
	
	public ParametersHandler() {
	}
	
	private List<String> parameters = null;
	
	@Override
	protected void installDescriptors(
			FPNode currentNode,
			XMLPadDocument document, 
			int offset, 
			String activatorString ) {
		if ( parameters != null ) {
			Icon ii = new ImageIcon( getClass().getResource( "parameter" + ".png" ) );
			for ( String p : parameters ) {
				( ( BasicDescriptor )addDescriptor( new BasicDescriptor( p, ii ) ) ).setComment( "parameter" );
			}	
		}
	}

	public boolean haveDescriptors(
			FPNode currentNode,
			XMLPadDocument document, 
			boolean insertBefore, 
			int offset, 
			String activatorString ) {
		if ( activatorString == null ) {
			int line = document.getDefaultRootElement().getElementIndex( offset );
			int cpt = 0;
			for ( int i = line; i >= 0; i-- ) {
				Element e = document.getDefaultRootElement().getElement( i );
				int start = e.getStartOffset();
				int end = e.getEndOffset();
				if ( i == line ) {
					start = offset;
				}
				try {		
					parameters = null;
					for ( int j = start; j < end; j++ ) {
						if ( "{".equals( document.getText( j, 1 ) ) ) {
							cpt++;
						} else
							if ( "}".equals( document.getText( j, 1 ) ) ) {
								cpt--;
							}
					}
					String l = document.getText( start, ( end - start ) );
					if ( l.contains( "function" ) && cpt != 0 ) {
						int a = l.indexOf( "function" );
						int b = l.indexOf( "(", a + 1 );
						int c = l.indexOf( ")", a + 1 );
						if ( ( a > -1 ) && ( b > -1 ) && ( c > -1 ) ) {
							String parametersLine = l.substring( b + 1, c ).trim();
							if ( parametersLine.length() > 0 ) {
								String[] tmp = parametersLine.split( "," );
								if ( tmp.length > 0 ) {
									for ( int d = 0; d < tmp.length; d++ ) {
										tmp[ d ].trim();
									}
									parameters = Arrays.asList( tmp );
									return true;
								}
							}
						}
						return false;
					}
				} catch( BadLocationException ble ) {
				}
			}
			return false;
		} else
			return false;
	}

}
