package com.japisoft.editix.editor.json;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class JSONSyntaxDescription {
	
	// Fast test
	public boolean isDelimiter( char c ) {
		return ( c == '{' ) || 
					( c == '}' ) || 
						( c == ';' ) || 
							( c == '(' ) || 
								( c == ')' ) || 
										( c == '[' ) ||
											( c == ']' ) ||
												( c == ',' );
	}

	private static char[] DELIMITERS = {
		'{',
		'}',
		';',
		'(',
		')',
		',',
		'[',
		']'
	};

	public char[] getDelimiters() {
		return DELIMITERS;
	}
	
	public boolean isStringDelimiter( char c ) {
		return c == '\'' || c == '\"';
	}

	public boolean isStartingLinesComment( char c, char oldc ) {
		return c == '*' && oldc == '/';
	}
	
	public boolean isStoppingLinesComment( char c, char oldc ) {
		return c == '/' && oldc == '*'; 
	}
	
	public boolean isStartingLineComment( char c, char oldc ) {
		return c == '/' && oldc == '/';
	}
	
	public String[] getKeywords() {
		return RESERVED_KEYWORDS;
	}

	// JS Keywords ECMA Script 6
	private static String[] RESERVED_KEYWORDS = {
		"break",
		"case",
		"class",
		"catch",
		"const",
		"continue",
		"debugger",
		"default",
		"delete",
		"do",
		"else",
		"export",
		"extends",
		"finally",
		"for",
		"function",
		"if",
		"import",
		"in",
		"instanceof",
		"let",
		"new",
		"null",
		"return",
		"super",
		"switch",
		"this",
		"throw",
		"try",
		"typeof",
		"var",
		"void",
		"while",
		"with",
		"yield"
	};

}
