package com.japisoft.editix.editor.json.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.japisoft.editix.editor.json.JSONContainer;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.xmlpad.error.ErrorManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CheckAction extends AbstractAction {
	
	public void actionPerformed(ActionEvent e) {
		JSONContainer jsc = ( JSONContainer )EditixFrame.THIS.getSelectedContainer();
		String text = jsc.getText();
		ErrorManager rm = jsc.getErrorManager();
		rm.notifyNoError(false);
		rm.initErrorProcessing();
		
		try {
			if ( text.trim().startsWith( "[" ) ) {
				new JSONArray( text );
			} else
				new JSONObject( text );
			EditixFactory.buildAndShowInformationDialog( "Your document is correct" );
		} catch( JSONException exc ) {
			rm.notifyError( this, true, null, exc.line, -1, exc.offset, exc.getMessage(), false );
			EditixFactory.buildAndShowErrorDialog( "Error(s) found" );
		}

		rm.stopErrorProcessing();
	}

}
