package com.japisoft.editix.editor.jsx.action;

import com.japisoft.editix.editor.jsx.domapi.Document;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.xml.DOMToolkit;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NodeFactory {

	private static NodeFactory instance = null;
	
	private NodeFactory() {
		instance = this;
	}
	
	public static NodeFactory newInstance() {
		if ( instance == null ) {
			new NodeFactory();
		}
		return instance;
	}
	
	public static Document getDocument( String location ) {
		try {
			org.w3c.dom.Document doc = DOMToolkit.parse( true, location );
			return new Document( location, doc );
		} catch( Exception exc ) {
			exc.printStackTrace();
			EditixFactory.buildAndShowErrorDialog( "Can't load " + location + " : " + exc.getMessage() );
			return null;
		}
	}
	
}
