package com.japisoft.editix.editor.xsd.view.designer;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;

import javax.swing.ImageIcon;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSDKeyComponentImpl extends XSDAbstractComponentImpl {

	static final ImageIcon KEY_ICON = new ImageIcon(
			XSDSequenceComponentImpl.class.getResource("key.png"));

	protected ImageIcon mainImage;
	
	public XSDKeyComponentImpl() {
		super();
		hasOpenIcon = false;
		mainImage = KEY_ICON;
		paintElementName = false;
		paintName = false;
	}	
	
	protected void paintSpecialContent( Graphics2D g ) {
		int w = getWidth();
		int h = getHeight();

		g.drawImage( mainImage.getImage(), 
				( ( w - mainImage.getIconWidth() ) / 2 ),
				( ( h - mainImage.getIconHeight() ) / 2 ), null );
	}	
	
	protected Shape createBorderShape() {

		return new Ellipse2D.Double(
			1,
			1,
			getWidth() - 2,
			getHeight() - 2
		);

	}

	public Dimension getPreferredSize() {
		return new Dimension( 30, 30 );
	}

	public Rectangle getVisibleBounds() {
		return new Rectangle( 0, 0, 30, 30 );
	}
	
}
