package com.japisoft.editix.editor.xsd.view.designer.container;

import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;

import com.japisoft.editix.editor.xsd.view.DesignerViewImpl;
import com.japisoft.editix.editor.xsd.view.designer.XSDAbstractComponentImpl;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSDContainerComponentImpl extends XSDAbstractComponentImpl {

	public XSDContainerComponentImpl() {
		float[] dash = { 5.0f };
		borderStyle = new BasicStroke(1.0f, BasicStroke.CAP_BUTT,
		        BasicStroke.JOIN_MITER, 5.0f, dash, 0.0f);
		setLayout( new BorderLayout( 20, 20 ) );
		opened = true; 	// Always open
		hasOpenIcon = false;
		paintName = false;
		setBackground( new Color( 230, 250, 230 ) );
	}

	// (annotation?, (simpleContent | complexContent | ((group | all |
	// choice | sequence)?, ((attribute | attributeGroup)*,
	// anyAttribute?))))
	
	public Dimension getPreferredSize() {
		Dimension layoutDimension = getLayout().preferredLayoutSize( this );
		return new Dimension(
				Math.max( layoutDimension.width, 70 ) + 10,
				Math.max( layoutDimension.height, 70 ) + 20
		);
	}

	public void paintComponent(Graphics g) {
		super.paintComponent( g );
		g.setColor( Color.GRAY );
		DesignerViewImpl.drawElementLines( getElement(), g );
	}	
	
}
