package com.japisoft.editix.editor.xsd.view2.node;

import org.w3c.dom.Element;

import com.japisoft.editix.editor.xsd.view2.nodeview.XSDNodeView;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface XSDNode {

	public int getChildCount();
	
	public XSDNode getChildAt( int index );
	
	public XSDNodeView getView();
	
	public boolean isOpened();
	
	public void setOpened( boolean state );
	
	public boolean isSelected();
	
	public boolean isMarked();
	
	public void setSelected( boolean selected );
	
	public void setData( String name, Object value );
	
	public Object getData( String name );
	
	public Element getDOM();
	
	public void setParent( XSDNode parent );
	
	public void repaint();
	
	public void invalidate();
	
	public void remove();
	
	public XSDNode getParent();
	
	public XSDNode add( String nodeName );
	
	public XSDNode insert( String nodeName );
	
	public boolean append( Element newChildren );
	
	public boolean isRoot();
	
	public boolean match( String name );
		
	public boolean isEnabled();
	
	public boolean containsNode( Element node );
	
	public boolean isReference();
	
	public String getReferenceName();
	
	public void moveUp();
	
	public void moveDown();
	
	public void dump();
	
}
