package com.japisoft.editix.javascript;

import java.io.Reader;

import javax.script.Bindings;
import javax.script.ScriptContext;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineFactory;
import javax.script.ScriptException;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EmptyEngine implements ScriptEngine {

	@Override
	public Bindings createBindings() {
		return null;
	}

	@Override
	public Object eval(String script) throws ScriptException {
		throw new ScriptException( "No JavaScript Engine, check your Java VM config" );
	}

	@Override
	public Object eval(Reader reader) throws ScriptException {
		throw new ScriptException( "No JavaScript Engine, check your Java VM config" );
	}

	@Override
	public Object eval(String script, ScriptContext context) throws ScriptException {
		throw new ScriptException( "No JavaScript Engine, check your Java VM config" );
	}

	@Override
	public Object eval(Reader reader, ScriptContext context) throws ScriptException {
		throw new ScriptException( "No JavaScript Engine, check your JavaVM config" );
	}

	@Override
	public Object eval(String script, Bindings n) throws ScriptException {
		throw new ScriptException( "No JavaScript Engine, check your JavaVM config" );
	}

	@Override
	public Object eval(Reader reader, Bindings n) throws ScriptException {
		throw new ScriptException( "No JavaScript Engine, check your JavaVM config" );
	}

	@Override
	public Object get(String key) {
		return null;
	}

	@Override
	public Bindings getBindings(int scope) {
		return null;
	}

	@Override
	public ScriptContext getContext() {
		return null;
	}

	@Override
	public ScriptEngineFactory getFactory() {
		return null;
	}

	@Override
	public void put(String key, Object value) {
	}

	@Override
	public void setBindings(Bindings bindings, int scope) {
	}

	@Override
	public void setContext(ScriptContext context) {
	}

}
