package com.japisoft.editix.main;

import java.io.File;
import java.util.List;

import com.apple.eawt.AboutHandler;
import com.apple.eawt.Application;
import com.apple.eawt.OpenFilesHandler;
import com.apple.eawt.PreferencesHandler;
import com.apple.eawt.QuitHandler;
import com.apple.eawt.QuitResponse;
import com.apple.eawt.AppEvent.AboutEvent;
import com.apple.eawt.AppEvent.OpenFilesEvent;
import com.apple.eawt.AppEvent.PreferencesEvent;
import com.apple.eawt.AppEvent.QuitEvent;
import com.japisoft.editix.action.file.OpenAction;
import com.japisoft.framework.application.descriptor.ActionModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class MacOSXMain {
	
	MacOSXMain() {
		try {
			MacOSXApplication m = new MacOSXApplication();
			Application app = Application.getApplication();
			app.setOpenFileHandler( m );
			app.setQuitHandler( m );
			app.setAboutHandler( m );
			app.setPreferencesHandler( m );
		} catch( Throwable th ) {
			System.out.println( "Can't use Java Extension for Mac OS X...");
			th.printStackTrace();
		}
	}

	static class MacOSXApplication implements AboutHandler, OpenFilesHandler, PreferencesHandler, QuitHandler {
		public void openFiles(OpenFilesEvent arg0) {
			List<File> files = arg0.getFiles();
			if ( files != null ) {
				for ( File f : files ) {
					OpenAction.openFile( null, false, f, null );
				}
			}			
		}
		public void handleQuitRequestWith(QuitEvent arg0, QuitResponse arg1) {
			ActionModel.activeActionById( "quit", null );
		}
		public void handleAbout(AboutEvent arg0) {
			ActionModel.activeActionById( "about", null );
		}
		public void handlePreferences(PreferencesEvent arg0) {
			ActionModel.activeActionById( "preferences", null );
		}
	}
	
}
