package com.japisoft.editix.main.steps;

import java.io.File;

import javax.swing.SwingUtilities;

import com.japisoft.editix.action.file.OpenAction;
import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.framework.ApplicationStep;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class StartingFilesApplicationStep implements ApplicationStep {

	public boolean isFinal() {
		return false;
	}

	public void start(String[] args) {
				
		for ( String file : args ) {
			final String file2 = file;
			SwingUtilities.invokeLater(
				new Runnable() {
					public void run() {
						OpenAction.openFile(
								null,
								false,
								new File( file2 ),
								null
						);											
					}
				} 
			);
		}
	}

	public void stop() {
	}
	
	@Override
	public void quit() {
	}

}
