package com.japisoft.editix.plugin;

import javax.swing.text.BadLocationException;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TestPlugin implements EditixPlugin {

	/** @return the name of the plugin */
	public String getName() {
		return "Hello world";
	}

	public void init() {
		System.out.println( "init" );
	}

	/** Start the plugin and insert Hello world at the current document location */
	public void start(PluginContext context) {
		try {
			System.out.println( "start " + context.getPath() );
			context.getDocument().insertString(
				context.getLocation(), "Hello world!", null );
		} catch( BadLocationException exc ) {
		}
	}

}
