package com.japisoft.editix.ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditixEditorFrameModel extends ArrayList 
		implements ActionListener {

	public static EditixEditorFrameModel ACCESSOR = null;
	private static int ID = 1;

	public static int addEditixEditorFrame( EditixEditorFrame frame ) {
		if ( ACCESSOR == null )
			ACCESSOR = new EditixEditorFrameModel();
		
		if ( ACCESSOR.size() == 0 ) // Reset the frame counter
			ID = 1;
		
		ACCESSOR.add( frame );
		// Update the menu
		JMenu menu = EditixFrame.THIS.getBuilder().getMenu( "extracted" );
		menu.setEnabled( true );
		String title = "Frame " + ID;
		if ( frame.getXMLContainer().getCurrentDocumentLocation() != null )
			title = title + " ( " + frame.getXMLContainer().getCurrentDocumentLocation() + " )";
		frame.getXMLContainer().setProperty( "id", "" + ID );
		JMenuItem item = new JMenuItem( title );
		item.addActionListener( ACCESSOR );
		item.setActionCommand( "" + ID );
		menu.add( item );
		ID++;
		return ( ID - 1 );
	}

	public static void removeEditixEditorFrame( EditixEditorFrame frame ) {
		String id = ( String )frame.getXMLContainer().getProperty( "id" );
		JMenu menu = EditixFrame.THIS.getBuilder().getMenu( "extracted" );
		for ( int i = 0; i < menu.getMenuComponentCount(); i++ ) {
			JMenuItem item = ( JMenuItem )menu.getMenuComponent( i );
			if ( item.getActionCommand().equals( id ) ) {
				item.removeActionListener( ACCESSOR );
				menu.remove( item );
				break;
			}
		}
		menu.setEnabled( menu.getMenuComponentCount() > 0 );
		ACCESSOR.remove( frame );
	}

	public void actionPerformed( ActionEvent e ) {
		String id = e.getActionCommand();
		for ( int i = 0; i < getXMLContainerCount(); i++ ) {
			EditixEditorFrame frame = ( EditixEditorFrame )ACCESSOR.get( i );
			if ( frame.getXMLContainer().getProperty( "id" ).equals( id ) ) {
				active( frame );
				break;
			}
		}
	}
	
	public static int getXMLContainerCount() {
		if ( ACCESSOR == null )
			return 0;
		return ACCESSOR.size();
	}

	public static XMLContainer getXMLContainer( int index ) {
		EditixEditorFrame frame = ( EditixEditorFrame )ACCESSOR.get( index );
		return frame.getXMLContainer();
	}

	public static IXMLPanel getIXMLPanel( int index ) {
		EditixEditorFrame frame = ( EditixEditorFrame )ACCESSOR.get( index );
		return frame.getIXMLPanel();		
	}

	public static void active( int index ) {
		EditixEditorFrame frame = ( EditixEditorFrame )ACCESSOR.get( index );
		active( frame );
	}

	public static void active( EditixEditorFrame frame ) {
		frame.toFront();
		XMLContainer currentContainer = frame.getXMLContainer();
		EditixFrame.THIS.updateCurrentXMLContainer( currentContainer );
	}
	
	public static XMLContainer getSelectedXMLContainer() {
		for ( int i = 0; i < getXMLContainerCount(); i++ ) {
			EditixEditorFrame frame = ( EditixEditorFrame )ACCESSOR.get( i );
			if ( frame.isActive() )
				return frame.getXMLContainer();
		}
		return null;
	}

}
