package com.japisoft.editix.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.japisoft.framework.preferences.Preferences;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class InformationDialog extends JDialog implements ActionListener {
	
	JButton btn;
	JCheckBox cb;
	String systemKey;

	public InformationDialog( JLabel content, String systemKey ) {
		super( EditixFrame.THIS );
		this.systemKey = systemKey;
		setModal( true );
		setDefaultLookAndFeelDecorated( false );
		setTitle( "Information" );
		getContentPane().add( content );
		
		JPanel panel2 = new JPanel();
		panel2.setLayout( new BorderLayout() );
		cb = new JCheckBox( "Show this dialog the next time", true );
		btn = new JButton( "OK" );
		panel2.add( BorderLayout.WEST, cb );
		panel2.add( BorderLayout.EAST, btn );
		
		getContentPane().add( BorderLayout.SOUTH, panel2 );
		
		pack();
		setSize( getWidth() + 20, getHeight() + 20 );
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation( 
				( dim.width - getWidth() ) / 2, 
				( dim.height - getHeight() ) / 2 );
	}

	public void setVisible( boolean state ) {
		super.setVisible( state );
	}
	
	public void addNotify() {
		super.addNotify();
		btn.addActionListener( this );
		cb.addActionListener( this );
	}
	
	public void removeNotify() {
		super.removeNotify();
		btn.removeActionListener( this );
		cb.removeActionListener( this );
	}

	public void actionPerformed( ActionEvent e ) {
		if ( e.getSource() == btn )
			setVisible( false );
		else {
			Preferences.setRawPreference( "system", systemKey, new Boolean( cb.isSelected() ) );
			// Preferences.setRawPreference( "system", "taskdialog" + message, new Boolean( cb.isSelected() ) );
		}
	}
}
