package com.japisoft.editix.ui;

import java.util.ArrayList;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class PanelStateManager {

	private static ArrayList panels = null;
	
	public static void addPanelStateListener( PanelStateListener listener ) {
		if ( panels == null )
			panels = new ArrayList();
		panels.add( listener );
	}

	// Don't call
	static void fireCurrentXMLContainer( XMLContainer container ) {
		if ( panels != null ) {
			for ( int i = 0; i < panels.size(); i++ ) {
				( ( PanelStateListener )panels.get( i ) ).setCurrentXMLContainer( 
						container );
			}
		}
	}

	// Don't call
	static void fireNewPath( String previousPath, String newPath ) {
		if ( panels != null ) {
			for ( int i = 0; i < panels.size(); i++ ) {
				( ( PanelStateListener )panels.get( i ) ).newPath( 
						previousPath, newPath );
			}
		}		
	}
	
	// Don't call
	static void fireClose( XMLContainer container ) {
		if ( panels != null ) {
			for ( int i = 0; i < panels.size(); i++ ) {
				( ( PanelStateListener )panels.get( i ) ).close( container );
			}
		}				
	}

}
 
