package com.japisoft.editix.ui.panels.diff;

import java.awt.Color;

import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DiffResourceFactory {

	static ImageIcon DEF = new ImageIcon( ClassLoader.getSystemResource( "images/element_ok.png" ) ); 
	static ImageIcon ADD = new ImageIcon( ClassLoader.getSystemResource( "images/element_add.png" ) ); 
	static ImageIcon MINUS = new ImageIcon( ClassLoader.getSystemResource( "images/element_delete.png" ) ); 
	static ImageIcon ATT = new ImageIcon( ClassLoader.getSystemResource( "images/element_new.png" ) );
	
	static final int ADD_TYPE = 0;
	static final int REMOVE_TYPE = 1;
	static final int ATT_TYPE = 2;
	
	public static Icon getIconForType( int type ) {

		if ( type == ADD_TYPE )
			return ADD;
		else
		if ( type == REMOVE_TYPE )
			return MINUS;
		else
		if ( type == ATT_TYPE )
			return ATT;
		
		return DEF;
	}

	static Color COLOR_REMOVED = new Color( 220, 150, 150 );
	static Color COLOR_ADDED  = new Color( 150, 150, 220 );
	static Color COLOR_ATT = new Color( 255, 239, 146 );
//	static Color COLOR_DESCENDANT = new Color( 150, 220, 150 );
//	static Color COLOR_MOVE = new Color( 220, 220, 150 );
	
	public static Color getBgColorForType( int type ) {

		if ( type == ADD_TYPE )
			return COLOR_ADDED;
		else
		if ( type == REMOVE_TYPE )
			return COLOR_REMOVED;
		else
		if ( type == ATT_TYPE )
			return COLOR_ATT;
		
		return Color.WHITE;
	}

}
