package com.japisoft.editix.ui.panels.search;

import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Enumeration;

import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

import com.japisoft.editix.action.panels.ui.TableToolBar;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.ui.table.ExportableTable;
import com.japisoft.framework.ui.table.StringTableCellRenderer;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.framework.xml.parser.walker.AttributeCriteria;
import com.japisoft.framework.xml.parser.walker.NamespacePrefixCriteria;
import com.japisoft.framework.xml.parser.walker.NamespaceURICriteria;
import com.japisoft.framework.xml.parser.walker.NodeNameCriteria;
import com.japisoft.framework.xml.parser.walker.TextCriteria;
import com.japisoft.framework.xml.parser.walker.TreeWalker;
import com.japisoft.framework.xml.parser.walker.ValidCriteria;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SearchUI 
	extends JPanel 
		implements 
			ActionListener,
			ListSelectionListener {

	public SearchUI() {
		initComponents();	
		
		getActionMap().put( "run", new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				btnApplyFromRoot.doClick();
			}
		});
		
		getInputMap( JPanel.WHEN_IN_FOCUSED_WINDOW ).put( 
				KeyStroke.getKeyStroke( KeyEvent.VK_ENTER, KeyEvent.CTRL_DOWN_MASK), "run" );
		
		Icon i = com.japisoft.framework.ui.Toolkit.getIconFromClasspath("images/gear_run.png");		
		
		btnApplyFromRoot.setIcon( i );
		btnApplyFromCurrent.setIcon( i );
	}

	JLabel lblCriteria = new JLabel();

	JComboBox cbCriteria = new JComboBox();

	JLabel jLabel1 = new JLabel(), jLabel2 = new JLabel();
	JTextField txtValue = new JTextField();
	JButton btnApplyFromRoot = new JButton();
	JButton btnApplyFromCurrent = new JButton();
	JScrollPane spResult = new JScrollPane();
	JTable tbResult = new ExportableTable() {
		public boolean isCellEditable(int row, int column) {
			return false;
		}
	};
    private javax.swing.JCheckBox cbCase;
    private javax.swing.JCheckBox cbContains;
    private JToolBar jToolBar1;
    
	GridBagLayout gridBagLayout1 = new GridBagLayout();

	   /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">                          
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        cbCriteria = new javax.swing.JComboBox();
        cbCase = new javax.swing.JCheckBox();
        cbContains = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        txtValue = new javax.swing.JTextField();
        btnApplyFromRoot = new javax.swing.JButton();
        btnApplyFromCurrent = new javax.swing.JButton();
        JScrollPane jScrollPane1 = new javax.swing.JScrollPane();

        jToolBar1 = new TableToolBar( tbResult );

        jLabel1.setText("Search For :");

        cbCriteria.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "TAG", "ATTRIBUTE NAME", "ATTRIBUTE VALUE", "TEXT", "TAG PREFIX", "TAG NAMESPACE URI" }));

        cbCase.setSelected(true);
        cbCase.setText("Ignore case");

        cbContains.setText("Contains");

        jLabel2.setText("With value :");

        btnApplyFromRoot.setText("From root");

        btnApplyFromCurrent.setText("From current");

        jScrollPane1.setViewportView(tbResult);

        jToolBar1.setRollover(true);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cbCriteria, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtValue))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(cbCase)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(cbContains))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(btnApplyFromRoot)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnApplyFromCurrent)))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(cbCriteria, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cbCase)
                    .addComponent(cbContains))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtValue, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnApplyFromRoot)
                    .addComponent(btnApplyFromCurrent))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
    }// </editor-fold>     	
	
	private void jbInit() {
		tbResult.getSelectionModel().setSelectionMode(
				ListSelectionModel.SINGLE_SELECTION );

        jLabel1.setText("Select your search criteria");
        jLabel2.setText("<html><body>Value <b><font size='-2'>(Enter for running)</font></b></b></body></html>");
        btnApplyFromRoot.setText("Search From Root");
        btnApplyFromRoot.setToolTipText("Search from root node");
        btnApplyFromCurrent.setText("Search From Current");
        btnApplyFromCurrent.setToolTipText("search from the current node");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, spResult, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 228, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, cbCriteria, 0, 228, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel1)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel2)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, txtValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 228, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnApplyFromRoot)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnApplyFromCurrent))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(cbCriteria, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(txtValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnApplyFromRoot)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnApplyFromCurrent)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(spResult, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 233, Short.MAX_VALUE)
                .addContainerGap())
        );

        spResult.getViewport().add(tbResult, null);
	}

	public void addNotify() {
		super.addNotify();
		btnApplyFromCurrent.addActionListener( this );
		btnApplyFromRoot.addActionListener( this );
		tbResult.getSelectionModel().addListSelectionListener(this);	
		txtValue.addActionListener( this );
	}	
	
	public void removeNotify() {
		super.removeNotify();
		btnApplyFromCurrent.removeActionListener( this );
		btnApplyFromRoot.removeActionListener( this );
		tbResult.getSelectionModel().removeListSelectionListener(this);
		txtValue.removeActionListener( this );
	}
	
	private String lastDocumentLocation = null;
	
	// Special case when activating by the editor popup
	public void searchByParam( String param ) {
		if ( param.startsWith( "e" ) ) {
			cbCriteria.setSelectedIndex( 0 );
		} else
		if ( param.startsWith( "a" ) ) {
			cbCriteria.setSelectedIndex( 1 );
		}
		txtValue.setText( param.substring( 1 ) );
		actionPerformed( null );
	}

	public void actionPerformed( ActionEvent e ) {
		FPNode node = null;
		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if ( container == null ) {
			EditixFactory.buildAndShowErrorDialog( "No document" );
			return;
		}
		
		lastDocumentLocation = container.getCurrentDocumentLocation();
		
		if ( e != null ) {
			if ( e.getSource() == btnApplyFromCurrent ) {
				node = container.getCurrentNode();			
			} else
				if ( e.getSource() == btnApplyFromRoot ) {
					if ( container.getTree() == null ) {
						EditixFactory.buildAndShowErrorDialog( "No available tree" );
						return;
					}
					node = ( FPNode )container.getTree().getModel().getRoot();
				} else {
					// From textfield event
					node = ( FPNode )container.getTree().getModel().getRoot();
				}
		} else {
			node = ( FPNode )container.getTree().getModel().getRoot();
		}

		if ( node == null )
			EditixFactory.buildAndShowErrorDialog( "No node" );
		else {
			unshowResult();
			TreeWalker tw = new TreeWalker( node );

			ValidCriteria vc = null;
			
			if ( cbCriteria.getSelectedIndex() == 0 ) {
				vc = new NodeNameCriteria( txtValue.getText() );
			}
			else
			if ( cbCriteria.getSelectedIndex() == 1 ) 
				vc = new AttributeCriteria( txtValue.getText() );
			else
			if ( cbCriteria.getSelectedIndex() == 2 ) 
				vc = new AttributeCriteria( AttributeCriteria.ANY_ATTRIBUTE, txtValue.getText() );
			else
			if ( cbCriteria.getSelectedIndex() == 3 ) 
				vc = new TextCriteria( txtValue.getText() );
			else
			if ( cbCriteria.getSelectedIndex() == 4 )
				vc = new NamespacePrefixCriteria( txtValue.getText() );
			else
			if ( cbCriteria.getSelectedIndex() == 5 )
				vc = new NamespaceURICriteria( txtValue.getText() );
				
			vc.setContainsMode( cbContains.isSelected() );
			vc.setIgnoreCase( cbCase.isSelected() );

			showResult( 
					tw.getNodeByCriteria( vc, true ), 
					txtValue.getText(), 
					cbCriteria.getSelectedIndex() );
		}
	}

	private void showResult( Enumeration e, String value, int type ) {
		String secondColomn = null;
		ArrayList r = new ArrayList();
		boolean added = false;
		
		for ( ; e.hasMoreElements() ; ) {
			
			added = false;
			
			FPNode result = 
				( FPNode )e.nextElement();

			if ( result.isText() )
				result = result.getFPParent();

			if ( result.isTag() ) {
				
				if ( type == 1 ) {
					secondColomn = value + " attribute";
					added = true;
					r.add( new Object[] {
							result,
							result.getAttribute( value )
					} );
				}

				if ( !added ) {
					if ( !result.isLeaf() ) {
						FPNode childNode = result.childAt( 0 );
						if ( childNode.isText() ) {
							if ( secondColomn == null )
								secondColomn = "First text";
	
							added = true;
							r.add(
									new Object[] {
											result,
											childNode.getContent()
									} );
						}
					} 
	
					if ( !added ) {
						
						if ( result.getFirstAttributeValue() != null ) {
							if ( secondColomn == null )
								secondColomn = "First attribute";
							r.add( 
									new Object[] {
											result,
											result.getFirstAttributeValue()		
									} 
							);
						} else
							r.add(
									new Object[] {
											result	
									} );
						}
	
					}
				}
		}

		DefaultTableModel model = null;

		if ( secondColomn != null )
			model = new DefaultTableModel( 0, 2 );
		else
			model = new DefaultTableModel( 0, 1 );

		for ( int i = 0; i < r.size(); i++ )
			model.addRow( 
					( Object[] )r.get( i ) 
			);

		if ( secondColomn != null ) {
			model.setColumnIdentifiers( 
					new String[] { 
							"Node (" + r.size() + " found)", 
							secondColomn } );
		} else {
			model.setColumnIdentifiers(
					new String[] {
							"Node (" + r.size() + " found)"
					} );			
		}

		tbResult.setModel( model );

		TableRowSorter<TableModel> sorter = 
			new TableRowSorter<TableModel>( model );
		
		sorter.setComparator( 0, 
			new Comparator<FPNode>() {
				public int compare(FPNode o1, FPNode o2) {
					return o1.getContent().compareTo( o2.getContent() );
				}
			} 
		);

		tbResult.setRowSorter( sorter ); 
		
		StringTableCellRenderer.fillIt( tbResult );
	}

	private void unshowResult() {
		DefaultTableModel model =
			new DefaultTableModel(
					new String[] {" No result " }, 
					0
			);
		tbResult.setModel( model );
	}

	public void valueChanged(ListSelectionEvent e) {
		int row = tbResult.getSelectedRow();

		if (row > -1) {
			
			row = tbResult.convertRowIndexToModel( row );
			
			FPNode n = (FPNode) tbResult.getModel().getValueAt(row, 0);
			
			if ( lastDocumentLocation != null ) {
				boolean ok = EditixFrame.THIS.activeXMLContainer( lastDocumentLocation );
				if ( !ok )
					return;
			}

			XMLContainer container =
				EditixFrame.THIS.getSelectedContainer();
			if (n.getStartingLine() > 0 && container != null ) {
				container.getEditor().highlightLine(n.getStartingLine());
			}
		}
	}

}
