package com.japisoft.editix.ui.panels.xslscenarios.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import com.japisoft.editix.ui.panels.Panel;
import com.japisoft.editix.ui.panels.PanelManager;
import com.japisoft.editix.ui.panels.snippet.SnippetPanel;
import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
abstract class CommonAction extends AbstractAction {
	
	static final String REN_CMD = "ren";
	static final String DEL_CMD = "del";
	static final String ADDD_CMD = "addd";
	static final String ADDS_CMD = "add";
	static final String RUN_CMD = "run";
	
	public void actionPerformed( ActionEvent e ) {
		Panel p = PanelManager.getPanelByAction( 
				"xslscenarios" );
		if ( p == null ) {
			ApplicationModel.debug(
					"Wrong panel action : " + 
						SnippetPanel.class.getName() + 
							"???" );
		} else {
			if ( p.isShown() || 
					!mustBeInVisiblePanel() ) {
				Object view = p.getView();
				if ( view instanceof ActionListener ) {
					( ( ActionListener )view ).actionPerformed(
							new ActionEvent(
									e.getSource(),
									e.getID(),
									getActionCommand() ) );
				}
			}
		}
	}

	abstract String getActionCommand();

	public boolean mustBeInVisiblePanel() {
		return true;
	}

}
