package com.japisoft.editix.wizard.document;

import java.io.File;

import com.japisoft.editix.action.file.imp.spreadsheet.SpreadSheetImportAction;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.xml.XMLFileData;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XLSX2XMLDocument implements DocumentWizard {

	private File source;
	
	@Override
	public String start() {
		try {
			XMLFileData f = SpreadSheetImportAction.getXMLWizard( 
				new String[] { "xlsx" }, 
				new String[] { "Open XML - Spreadsheet (*.xlsx)" } 
			);
			source = new File( f.getURI() );
			return f.getContent();
		} catch( Exception exc ) {
			EditixFactory.buildAndShowErrorDialog( "Can't import this file : " + exc.getMessage() );
		}
		return null;
	}
	
	@Override
	public File getSource() {
		return source;
	}
	
}
