package com.japisoft.framework.css;

import java.util.HashMap;
import java.util.Map;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Toolkit {

	private static Map<String,Boolean> i = null;
	
	static {
		i = new HashMap<String,Boolean>();
		i.put( "color", Boolean.TRUE );
		i.put( "cursor", Boolean.TRUE );
		i.put( "font-family", Boolean.TRUE );
		i.put( "font-size", Boolean.TRUE );
		i.put( "font-style", Boolean.TRUE );
		i.put( "font-variant", Boolean.TRUE );
		i.put( "font-weight", Boolean.TRUE );
		i.put( "font", Boolean.TRUE );
		i.put( "text-align", Boolean.TRUE );
		i.put( "text-indent", Boolean.TRUE );
		i.put( "text-transform", Boolean.TRUE );		
		i.put( "visibility", Boolean.TRUE );				
	}
	
	public static boolean isInheritedProperty( String name ) {
		name = name.toLowerCase();
		if ( i.containsKey( name ) )
			return true;
		return false;
	}
	
	public static String[] getInheritedProperties() {
		return i.keySet().toArray( new String[ i.size() ] );
	}
	
}
