package com.japisoft.framework.dialog;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.UIManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BasicDialogHeader extends JPanel implements DialogHeader {

	JLabel lblTitle = new JLabel();
	JTextArea txaInfo = new JTextArea();
	JLabel lblImage = new JLabel();
	GridBagLayout gridBagLayout1 = new GridBagLayout();

	public BasicDialogHeader() {
		init();
	}

	static Color bgColor = UIManager.getColor( "editix.dialog.header" );

	static {
		if( bgColor == null ) {
			bgColor = new Color( Integer.parseInt( "333333", 16 ) ); 
		}
	}
	
	void init()  {
		lblTitle.setText( "Title" );
		lblTitle.setForeground( Color.WHITE );
		this.setBackground( bgColor );
		this.setLayout( gridBagLayout1 );
		txaInfo.setText( "..." );
		txaInfo.setEditable( false );
		txaInfo.setWrapStyleWord( true );
		txaInfo.setOpaque( false );
		txaInfo.setLineWrap( true );
		txaInfo.setForeground( Color.WHITE );
		lblImage.setText( "" );
		
		Font f = lblTitle.getFont();
		lblTitle.setFont( new Font( f.getName(), Font.BOLD, f.getSize() ) );
		
		this.add( lblTitle, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0,
				GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(2,
						6, 0, 0), 0, 0 ) );
		this.add( txaInfo, new GridBagConstraints( 0, 1, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						0, 21, 5, 0 ), 0, 0 ) );
		this.add( lblImage, new GridBagConstraints( 1, 0, 1, 2, 1.0, 1.0,
				GridBagConstraints.NORTHEAST, GridBagConstraints.NONE,
				new Insets(2, 6, 5, 4), 0, 0 ) );
	}

	////////////////////////////////////////////////////////

	public void setTitle(String title) {
		lblTitle.setText( title );
	}

	public void setComment(String comment) {
		txaInfo.setText( comment );
	}

	public void setIcon(Icon icon) {
		lblImage.setIcon( icon );
	}

	public JComponent getView() {
		return this;
	}

	public void dispose() {
	}
	
}
