package com.japisoft.framework.dialog;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.LayoutManager2;

import javax.swing.JComponent;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class ButtonLayout implements LayoutManager2 {

	public ButtonLayout() {
		super();
	}
	
	public ButtonLayout( int buttonSpace ) {
		super();
		setButtonSpace( buttonSpace );
	}
	
	public void addLayoutComponent(Component comp, Object constraints) {}

	public Dimension maximumLayoutSize(Container target) {
		return null;
	}

	public float getLayoutAlignmentX(Container target) {
		return 0;
	}

	public float getLayoutAlignmentY(Container target) {
		return 0;
	}

	public void invalidateLayout(Container target) {}
	public void addLayoutComponent(String name, Component comp) {}
	public void removeLayoutComponent(Component comp) {}

	public Dimension preferredLayoutSize( Container parent ) {
		Dimension ref = null;
		for ( int i = 0; i < parent.getComponentCount(); i++ ) {
			JComponent c = ( JComponent )parent.getComponent( i );
			if ( ref == null )
				ref = c.getPreferredSize();
			else {
				Dimension d = c.getPreferredSize();
				if ( d.width > ref.width || 
						d.height > ref.height )
					ref = d;
			}
		}
		if ( ref != null )
			ref.height += 10;
		else
			return new Dimension( 0, 0 );
		return ref;
	}

	public Dimension minimumLayoutSize(Container parent) {
		return preferredLayoutSize( parent );
	}

	private int buttonSpace = 0;
	
	public void setButtonSpace( int buttonSpace ) {
		this.buttonSpace = buttonSpace;
	}

	public void layoutContainer(Container parent) {
		int startX = parent.getWidth() - 5 - buttonSpace;
		int startY = 0;
		int startX2 = 5 + buttonSpace;

		for ( int i = 0; i < parent.getComponentCount(); i++ ) {
			JComponent comp = ( JComponent )parent.getComponent( i );
			Dimension ps = comp.getPreferredSize();
			startY = ( parent.getHeight() - ps.height ) / 2;
			if ( !( comp instanceof LeftOrientedButton ) ) {
				startX -= ( ps.getWidth() + buttonSpace );
				comp.setBounds( startX, startY + 1, ps.width, ps.height );
			} else {
				comp.setBounds( startX2, startY + 1, ps.width, ps.height );				
				startX2 += ps.getWidth() + buttonSpace;
			}
		}
	}

}
