package com.japisoft.framework.dialog.about;

import java.awt.Window;
import java.util.HashMap;
import javax.swing.ImageIcon;

import com.japisoft.framework.ApplicationMain;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.dialog.actions.DialogActionModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class AboutDialog {


	

	/**
	 * @param owner Window parent
	 * @param product Product name
	 * @param version Product version
	 * @param build Product build
	 * @param company Company owner
	 * @param productLogo Product Logo
	 * @param registered User being registered can be <code>null</code>
	 * @return
	 */
	public static int showDialog(	
			Window owner,
			String product, 
			String version,
			String build,
			String company,
			String productLogo,
			String productInfo,
			String registered ) {

		HashMap map = new HashMap();
		if ( build != null )
			map.put( AboutPanel.BUILD_KEY, build );
		if ( company != null )
			map.put( AboutPanel.COMPANY_KEY, company );
		if ( product != null )
			map.put( AboutPanel.PRODUCT_KEY, product );
		if ( version != null )
			map.put( AboutPanel.VERSION_KEY, version );
		if ( productLogo != null ) {
			map.put( AboutPanel.IMAGE_KEY, new ImageIcon( ClassLoader.getSystemResource( productLogo ) ) );
		}
		if ( registered != null )
			map.put( AboutPanel.REGISTERED_KEY, registered );

		return DialogManager.showDialog(
				owner,
				"About",
				"About " + product,
				productInfo,
				null,
				new AboutPanel( map ),
				DialogActionModel.getDefaultDialogOkActionModel(),
				null
		);

	}

}
