package com.japisoft.framework.dialog.about;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.io.InputStream;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;

import com.japisoft.framework.app.toolkit.Toolkit;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NewsPanel extends JPanel {

	public NewsPanel() {
		InputStream input = ClassLoader.getSystemResourceAsStream( "NEWS.TXT" );
		if ( input == null )
			return;
		String text = "no news found : Required the file NEWS.TXT";
		try {
			text = Toolkit.getContentFromInputStream( input, null );
		} catch( Throwable th ) {
		}
		setLayout( new BorderLayout() );
		
		InputStream input2 = ClassLoader.getSystemResourceAsStream( "BUILD.TXT" );		
		
		JTextArea ta = null;
		
		if ( input2 == null ) {
			add( new JScrollPane( 
				ta = new JTextArea( text ) ) );
		} else {

			JTabbedPane tb = new JTabbedPane( JTabbedPane.TOP );
			tb.addTab( "NEWS", new JScrollPane( 
				ta = new JTextArea( text ) ) );
			try {
				text = Toolkit.getContentFromInputStream( input2, null );
			} catch( Throwable th ) {
			}
			
			ta.setFont( new Font( "Courrier", Font.PLAIN, 11 ) );			
			
			tb.addTab( "BUILD", new JScrollPane( 
					ta = new JTextArea( text ) ) );
			tb.setSelectedIndex( 0 );
			add( tb );
			
		}

		setPreferredSize( new Dimension( 400, 400 ) );
	}

}
