package com.japisoft.framework.dialog.register;

import java.awt.Window;

import com.japisoft.framework.dialog.DialogManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RegisteredDialog {

	/**
	 * @param owner Window parent
	 * @param locationToOrder Site for ordering
	 * @param personalPrice Personal price for the product. It can be <code>null</code>
	 * @param companyPrice Company price for the product
	 * @param currency Currency for buying if null then 'US dollar' 
	 * @return The result pane if the user press 'OK' else <code>null</code>
	 */
	public static RegisteredPane showDialog( Window owner, String locationToOrder, String personalPrice, String companyPrice, String currency ) {
		RegisteredPane pane = new RegisteredPane( locationToOrder, personalPrice, companyPrice, currency == null ? "US Dollar ($)" : currency );
		if ( DialogManager.showDialog(
				owner,
				"Register", 
				"Register", 
				"You can order at " + locationToOrder + " and \nreceive instantly by mail your registered key",
				null,
				pane ) == DialogManager.OK_ID )
			return pane;
		
		return null;
	}

}
