package com.japisoft.framework.dialog.welcome;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Window;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import com.japisoft.framework.dialog.DialogManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class WelcomeDialog {

	/**
	 * @param owner Window parent
	 * @param companyLocation Company URL
	 * @param product Product name
	 * @param randomAds A set of message
	 * @param a An optional action
	 */
	public static int showDialog( Window owner, String companyLocation, String product, String[] randomAds, Action a ) {

		JPanel pane = new JPanel();
		JTextArea tp = new JTextArea();
		tp.setWrapStyleWord( true );
		tp.setLineWrap( true );
		tp.setEditable( false );
		try {
			int message = ( int )( ( Math.random() * randomAds.length )  );
			tp.setText( randomAds[ message ] );
		} catch( Throwable th ) {}
		pane.setLayout( new BorderLayout() );
		pane.add( new JScrollPane( tp ), BorderLayout.CENTER );
		if ( a != null ) {
			pane.add( new JButton( a ), BorderLayout.SOUTH );
		}

		DialogManager.resetDefaultSize( new Dimension( 400, 250 ) );
		
		return DialogManager.showDialog( owner,
				"Welcome to " + product,
				product,
				"Welcome. Get more information at " + companyLocation,
				null,
				pane );
	}

}

