package com.japisoft.framework.preferences;

import java.awt.Color;
import java.awt.Component;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellRenderer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TreeGroup extends JTree {
	
	public TreeGroup() {
		setCellRenderer( new CustomTreeCellRendererComponent() );
	}

	Icon i1 = new ImageIcon( ClassLoader.getSystemResource( "images/navigate_right.png" ) );
	Icon i2 = new ImageIcon( ClassLoader.getSystemResource( "images/navigate_right2.png" ) );
	Icon i3 = new ImageIcon( ClassLoader.getSystemResource( "images/pawn_glass_blue.png" ) );
	
	class CustomTreeCellRendererComponent extends JLabel implements TreeCellRenderer {
		public Component getTreeCellRendererComponent(
				JTree tree, 
				Object value, 
				boolean selected, 
				boolean expanded, 
				boolean leaf, 
				int row, 
				boolean hasFocus) {

			if ( !leaf )
				setIcon( i3 );
			else {
				if ( selected )
					setIcon( i2 );
				else
					setIcon( i1 );
			}
			
			setText( value.toString() );
			
			return this;
		}
	}
	
	

}
