package com.japisoft.framework.tools;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ExtendedStringTokenizer {

	private char[] line = null;
	private char colSep = 0;
	private char textSep = 0;
	private int l = 0;
	private String firstToken = null;
	
	/**
	 * @param line Line to scan
	 * @param colSep The separator of each column
	 * @param textSep The separator for each text like a quote */
	public ExtendedStringTokenizer( String line, char colSep, char textSep ) {
		this.line = line.toCharArray();
		this.colSep = colSep;
		this.textSep = textSep;
		firstToken = nextScan();
	}

	public boolean hasMoreTokens() {
		return ( l > -1 );
	}

	public String nextToken()  {
		if ( firstToken != null ) {
			String tmp = firstToken;
			firstToken = null;
			return tmp;
		}
		return nextScan();
	}

	private String nextScan() {
		if ( l == -1 )
			return null;
		if ( l >= line.length ) {
			l = -1;
			return "";
		} else {
			boolean startText = false;
			StringBuffer sb = null;
			while ( l < line.length ) {
				if ( line[ l ] == textSep ) {
					if ( startText ) {
						// We found the end
						//l++;
						//return sb.toString();
						
						startText = false;
						
					} else
						startText = true;
				} else
					if ( startText ) {
						if ( sb == null )
							sb = new StringBuffer();
						sb.append( line[ l ] );
					} else
						if ( line[ l ] == colSep ) {
							if ( sb != null ) {
								if ( l < line.length - 1 )
									l++;
								return sb.toString();
							} else {
								l++;
								if ( l == line.length )
									l = -1;
								return "";
							}
						} else {
							// This is character we must maintain until the next column separator
							if ( sb == null )
								sb = new StringBuffer();
							sb.append( line[ l ] );
						}
				l++;
			}
			l = -1;
			if ( sb != null ) {
				return sb.toString();
			}
			return "";
		}
	}

	public static void main( String[] test ) {

		ExtendedStringTokenizer est = new ExtendedStringTokenizer( ";'a';\"b\";\"c;cc\";;;d;", ';', '\"' );
		while ( est.hasMoreTokens() ) {
			System.out.println( "[" + est.nextToken() + "]" );
		}
		
	}

}
