package com.japisoft.framework.ui.list;

import java.awt.Component;
import java.io.File;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FileListCellRenderer implements ListCellRenderer {

	private JLabel lbl = new JLabel();
	
	public FileListCellRenderer() {
		lbl.setIcon(
				new ImageIcon(
						ClassLoader.getSystemResource( "images/document_plain.png" ) ) );
		lbl.setOpaque( true );
	}

	public Component getListCellRendererComponent(
			JList list, 
			Object value,
			int index, 
			boolean isSelected, 
			boolean cellHasFocus ) {
		
		if ( isSelected ) {
			lbl.setForeground( list.getSelectionForeground() );
			lbl.setBackground( list.getSelectionBackground() );
		} else {
			lbl.setForeground( list.getForeground() );
			lbl.setBackground( list.getBackground() );
		}
		
		File f = ( File )value;
		lbl.setText( f.toString() + " (" + f.length() + " bytes)" );

		return lbl;
	}

}
