package com.japisoft.framework.ui.toolkit;

import java.io.IOException;

import com.japisoft.framework.preferences.Preferences;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BrowserCaller {

	public static boolean displayURL(String url) {
		String cmd = null;
		try {
			Process p = null;
			if ( isWindowsPlatform() ) {
				String prefix = Preferences.getPreference( "viewer", "html", WIN_PATH + " " + WIN_FLAG );
				cmd = prefix + " " + url;
				p = Runtime.getRuntime().exec( cmd );
			} else
			if ( isMacOSXPlatform() ) {
				String prefix = Preferences.getPreference( "viewer", "html", MAC_PATH );
				cmd = prefix + " " + url;
				p = Runtime.getRuntime().exec( cmd );
			} else {
				String prefix = Preferences.getPreference( "viewer", "html", UNIX_PATH );
				//cmd = prefix + "(" + url + ")";
				cmd = prefix + " " + url;
				p = Runtime.getRuntime().exec( cmd );
			}
		} catch ( IOException x ) {
			return false;
		}
		return true;
	}

	public static boolean isWindowsPlatform() {
		String os = System.getProperty( "os.name" );
		if ( os != null && 
				( os.toLowerCase().indexOf( WIN_ID ) > -1 ) )
			return true;
		else
			return false;
	}

	public static boolean isMacOSXPlatform() {
		String os = System.getProperty( "os.name" );
		if ( os != null && 
				( os.toLowerCase().indexOf( MACOSX_ID ) > -1 ) )
			return true;
		return false;
	}

	private static final String MACOSX_ID = "mac os x";
	private static final String WIN_ID = "windows";

	public static final String WIN_PATH = "rundll32";
	public static final String WIN_FLAG = "url.dll,FileProtocolHandler";
	//private static final String UNIX_PATH = "netscape";
	public static final String UNIX_PATH = "firefox";
	//private static final String UNIX_FLAG = "-remote openURL";
	public static final String UNIX_FLAG = "";
	public static final String MAC_PATH = "open";
}
