package com.japisoft.framework.wizard;

import java.util.ArrayList;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DefaultWizardStepModel implements WizardStepModel {

	private ArrayList content;
	private JWizard wizard;

	public int getWizardStepIndex(WizardStep step) {
		if ( content == null )
			return -1;
		return content.indexOf( step );
	}

	public DefaultWizardStepModel( JWizard wizard ) {
		this.wizard = wizard;
	}

	public void addWizardStep(WizardStep step) {
		if ( content == null )
			content = new ArrayList();
		content.add( step );
	}

	public void insertWizardStep(int index, WizardStep step) {
		if ( content == null )
			content = new ArrayList();
		content.add( index, step );
	}

	public void removeWizardStep(WizardStep step) {
		if ( content != null ) {
			content.remove( step );
		}
	}

	public WizardStep getWizardByName(String name) {
		if ( name == null )
			throw new RuntimeException( "Illegal null name" );
		if ( content != null ) {
			for ( int i = 0; i < content.size(); i++ ) {
				WizardStep ws = ( WizardStep )content.get( i );
				if ( name.equals( ws.getName() ) )
					return ws;
			}
		}
		return null;
	}

	public WizardStep getWizardStep(int index) {
		if ( content == null )
			return null;
		return ( WizardStep )content.get( index );
	}

	public int getWizardStepCount() {
		if ( content == null )
			return 0;
		return content.size();
	}

}
