package com.japisoft.framework.wizard;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface WizardStepModel {

	/** Add a new wizard step */
	public void addWizardStep( WizardStep step );

	/** Insert a wizard step */
	public void insertWizardStep( int index, WizardStep step );

	/** Remove a wizard step */
	public void removeWizardStep( WizardStep step );

	/** @return an index starting from 0 for this wizard step */
	public int getWizardStepIndex( WizardStep step );

	/** @return a wizard by its name */
	public WizardStep getWizardByName( String name );

	/** @return the number of wizard step */
	public int getWizardStepCount();

	/** @return a wizard step at this index from 0 to the maximum size - 1 */
	public WizardStep getWizardStep( int index );

}
