package com.japisoft.framework.xml.action;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import org.apache.xml.resolver.CatalogManager;
import org.apache.xml.resolver.tools.CatalogResolver;
import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CustomEntityResolver extends CatalogResolver {

	CatalogManager manager;

	public CustomEntityResolver( CatalogManager manager) {
		super( manager );
		this.manager = manager;
		loadCatalogs();
	}

	static CustomEntityResolver RESOLVER = null;

	public static CustomEntityResolver getInstance() {
		if ( RESOLVER == null ) {
			RESOLVER = new CustomEntityResolver( CatalogManager.getStaticManager() );
			CatalogManager.getStaticManager().setRelativeCatalogs( false );
		}
		return RESOLVER;
	}

	public void loadCatalogs() {
		File catalog = XMLCatalogAction.getCatalogLstPath();
		if ( catalog.exists() ) {
			try {
				BufferedReader reader = new BufferedReader( 
						new FileReader( catalog ) );
				try {
					String line = null;
					StringBuffer sb = new StringBuffer();
					while ( ( line = reader.readLine() ) != null ) {
						if ( sb.length() > 0 )
							sb.append( ";" );
						sb.append( line );
					}
					ApplicationModel.debug( "RESET CATALOG FILES = " + sb.toString() );
					manager.setCatalogFiles( sb.toString() );
				} finally {
					reader.close();
				}

			} catch( IOException exc ) {}
		}		
		try {
			manager.getCatalog().loadSystemCatalogs();
		} catch( IOException exc ) {
			exc.printStackTrace();
		}
	}
	
}
