package com.japisoft.framework.xml.parser;

import java.util.HashMap;
import java.util.Map;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NameCollection {

	private Map<Integer,String> names = null;
	private Map<String,Integer> ids = null;	
	private int initialCapacity = 100;
	
	private static NameCollection THIS = null;

	private NameCollection() {
		THIS = this;
	}

	public static NameCollection getInstance() {
		if ( THIS == null )
			new NameCollection();
		return THIS;
	}
	
	private int id = 0;

	public synchronized int getId( String name ) {
		if ( ids == null )
			ids = new HashMap<String, Integer>( initialCapacity );
		Object res = ids.get( name );
		if ( res != null )
			return ( Integer )res;
		if ( names == null )
			names = new HashMap<Integer, String>( initialCapacity );
		id++;
		ids.put( name, id );
		names.put( id, name );
		return id;
	}

	public String getName( int id ) {
		if ( names == null )
			return null;
		return names.get( id );
	}
	
	public static void main( String[] args ) {
		int id = NameCollection.getInstance().getId( "hello" );
		System.out.println( id );
		id = NameCollection.getInstance().getId( "hello" );
		System.out.println( id );
		id = NameCollection.getInstance().getId( "hello2" );
		System.out.println( id );
		id = NameCollection.getInstance().getId( "hello2" );
		System.out.println( id );
		
	}
	
}
