package com.japisoft.framework.xml.parser;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ParseException extends Exception {


    public ParseException( String cause ) {
	super( cause );
    }

    
    public ParseException( String cause, int offset, int line ) {
    	super( cause );
    	this.line = line;
    	this.caret = offset;
    }
    
    
    private int caret;
    private int line;
    private int col;
    private String causeBy;

    void setCauseBy( String s ) {
	causeBy = s;
    }

    void setCaret( int caret ) {
	this.caret = caret;
    }

    void setLine( int line ) {
	this.line = line;
    }

    void setCol( int col ) {
	this.col = col;
    }

    /** @return the current error position starting from 0 */
    public int getCaret() { return caret; }
    /** @return the current error line */
    public int getLine() { return line; }
    /** @return the current error colomn */
    public int getCol() { return col; }

    /** @return a reason about the error */
    public String causeBy() { return causeBy; }

    public String toString() {
	return getMessage() + " i" + caret + " l" + line + " c" + col;
    }

}

// ParseException ends here
