package com.japisoft.framework.xml.parser.dom;

import org.w3c.dom.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DOMImplementationImpl implements DOMImplementation {
	public DOMImplementationImpl() {
		super();
	}

	/**
	 * Test if the DOM implementation implements a specific feature.
	 * @param feature The package name of the feature to test. In Level 1, the 
	 *   legal values are "HTML" and "XML" (case-insensitive).
	 * @param version This is the version number of the package name to test.  
	 *   In Level 1, this is the string "1.0". If the version is not specified, 
	 *   supporting any version of the  feature will cause the method to return 
	 *   <code>true</code>. 
	 * @return <code>true</code> if the feature is implemented in the specified 
	 *   version, <code>false</code> otherwise.
	 */
	public boolean hasFeature(String feature, String version) {
		return false;
	}

	public DocumentType createDocumentType(
		String qualifiedName,
		String publicId,
		String systemId)
		throws DOMException {
		throw new DOMExceptionImpl(
			DOMException.NOT_SUPPORTED_ERR,
			"Not supported");
	}

	public Document createDocument(
		String namespaceURI,
		String qualifiedName,
		DocumentType doctype)
		throws DOMException {
		return new DocumentImpl( (Element)null );
	}

	public Object getFeature(String feature, String version) {
		// TODO Auto-generated method stub
		return null;
	}

}

// DOMImplementationImpl ends here
