package com.japisoft.framework.xml.parser.dom;

import org.w3c.dom.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DocumentTypeImpl extends NodeImpl implements DocumentType {
	public DocumentTypeImpl() {
		super();
	}

	/**
	 * The name of DTD; i.e., the name immediately following the 
	 * <code>DOCTYPE</code> keyword.
	 */
	public String getName() {
		throw new RuntimeException("Not implemented");
	}

	/**
	 * A <code>NamedNodeMap</code> containing the general entities, both 
	 * external and internal, declared in the DTD. Duplicates are discarded. 
	 * For example in:&lt;!DOCTYPE ex SYSTEM "ex.dtd" [ &lt;!ENTITY foo 
	 * "foo"&gt; &lt;!ENTITY bar "bar"&gt; &lt;!ENTITY % baz "baz"&gt;]&gt;
	 * &lt;ex/&gt;  the interface provides access to <code>foo</code> and 
	 * <code>bar</code> but not <code>baz</code>. Every node in this map also 
	 * implements the <code>Entity</code> interface.
	 * <br>The DOM Level 1 does not support editing entities, therefore 
	 * <code>entities</code> cannot be altered in any way.
	 */
	public NamedNodeMap getEntities() {
		throw new RuntimeException("Not implemented");
	}
	/**
	 * A <code>NamedNodeMap</code> containing  the notations declared in the 
	 * DTD. Duplicates are discarded. Every node in this map also implements 
	 * the <code>Notation</code> interface.
	 * <br>The DOM Level 1 does not support editing notations, therefore 
	 * <code>notations</code> cannot be altered in any way.
	 */
	public NamedNodeMap getNotations() {
		throw new RuntimeException("Not implemented");
	}

	public String getPublicId() {
		throw new RuntimeException("Not implemented");
	}

	public String getSystemId() {
		throw new RuntimeException("Not implemented");
	}

	public String getInternalSubset() {
		return null;
	}
}

// DocumentTypeImpl ends here
