package com.japisoft.framework.xml.parser.dom;

import com.japisoft.framework.xml.parser.document.*;
import com.japisoft.framework.xml.parser.node.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DomNodeFactory implements NodeFactory {

	public DomNodeFactory() {
		super();
	}

	private Document refDoc;

	public void setRefDocument(Document doc) {
		this.refDoc = doc;
	}

	private static NodeFactory instance;

	/** @return a single instance of the node factory */
	public static NodeFactory getFactory() {
		if (instance == null)
			instance = new DomNodeFactory();
		return instance;
	}

	/** @return a text node */
	public FPNode getTextNode(String text) {
		FPNode node = new TextImpl(text);
		node.setDocument(refDoc);
		return node;
	}

	/** @return a tag node */
	public FPNode getTagNode(String tag) {
		FPNode node = new ElementImpl(tag);
		node.setDocument(refDoc);
		return node;
	}

	public FPNode getTagNode(int idTag) {
		FPNode node = new ElementImpl(idTag);
		node.setDocument(refDoc);
		return node;
	}	

	/** @return a comment node */
	public FPNode getCommentNode(String comment) {
		FPNode node = new CommentImpl(comment);
		node.setDocument(refDoc);
		return node;
	}

}

// DomNodeFactory ends here
