package com.japisoft.framework.xml.parser.walker;

import com.japisoft.framework.xml.parser.node.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NamespacePrefixCriteria extends AbstractCriteria {
	private String prefix;

	/** Match node in the following namespace prefix */
	public NamespacePrefixCriteria(String p) {
		super();
		this.prefix = p;
		if (p == null)
			throw new RuntimeException("invalid criteria prefix");
	}

	public boolean isValid(FPNode node) {
		if ( node.getNameSpacePrefix() == null )
			return false;
		
		if ( ignoreCase ) {
			
			if ( containsMode ) {
				
				return node.getNameSpacePrefix().toLowerCase().contains( prefix.toLowerCase() );
				
			} else
				return prefix.equalsIgnoreCase( node.getNameSpacePrefix() );
		} else {
			
			if ( containsMode ) {
				
				return node.getNameSpacePrefix().contains( prefix );
				
			} else {
				
				return prefix.equals( node.getNameSpacePrefix() );
				
			}

		}

	}

}
