package com.japisoft.framework.xml.parser.walker;

import com.japisoft.framework.xml.parser.node.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NodeNameCriteria extends AbstractCriteria {
    private String name;
    
    /** Search for the good 'name' */
    public NodeNameCriteria( String name ) {
    	super();   
		this.name = name;
		if ( name == null )
		    throw new RuntimeException( "Invalid criteria name" );
    }
    
    public boolean isValid( FPNode node ) {    	
    	if ( "*".equals( name ) )
    		return node.isTag();
    	
    	if ( node.isTag() ) {
    		
    		if ( ignoreCase ) {
    			
    			if ( containsMode ) {
    				
    				return node.getContent().toLowerCase().contains( name.toLowerCase() );
    				
    			} else {
    				
    				return name.equalsIgnoreCase( node.getContent() );
    				
    			}
    			
    		} else {
    			
    			if ( containsMode ) {
    	
    				return node.getContent().contains( name );
    				
    			} else
    				
    				return name.equals( node.getContent() );
    			
    		}
    		
    	} else
    		
    		return false;
    	
    }

}

// NodeNameCriteria ends here
