package com.japisoft.framework.xml.refactor.elements;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ProcessingInstruction;
import org.w3c.dom.UserDataHandler;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ProcessingInstructionProxyNode implements ProcessingInstruction {
	private ProcessingInstruction ref;
	private String newName;
	
	public ProcessingInstructionProxyNode( 
			ProcessingInstruction ref, 
			String newName ) {
		this.ref = ref;
		this.newName = newName;
	}
	
	public String getTarget() {
		return ref.getTarget();
	}

	public String getData() {
		return ref.getData();
	}

	public void setData(String arg0) throws DOMException {
		ref.setData( arg0 );
	}

	public String getNodeName() {
		if ( newName != null )
			return newName;
		return ref.getNodeName();
	}

	public String getNodeValue() throws DOMException {
		return ref.getNodeValue();
	}

	public void setNodeValue(String arg0) throws DOMException {
		ref.setNodeValue( arg0 );
	}

	public short getNodeType() {
		return ref.getNodeType();
	}

	public Node getParentNode() {
		return ref.getParentNode();
	}

	public NodeList getChildNodes() {
		return ref.getChildNodes();
	}

	public Node getFirstChild() {
		return ref.getFirstChild();
	}

	public Node getLastChild() {
		return ref.getLastChild();
	}

	public Node getPreviousSibling() {
		return ref.getPreviousSibling();
	}

	public Node getNextSibling() {
		return ref.getNextSibling();
	}

	public NamedNodeMap getAttributes() {
		return ref.getAttributes();
	}

	public Document getOwnerDocument() {
		return ref.getOwnerDocument();
	}

	public Node insertBefore(Node arg0, Node arg1) throws DOMException {
		return ref.insertBefore( arg0, arg1 );
	}

	public Node replaceChild(Node arg0, Node arg1) throws DOMException {
		return ref.replaceChild( arg0, arg1 );
	}

	public Node removeChild(Node arg0) throws DOMException {
		return ref.removeChild( arg0 );
	}

	public Node appendChild(Node arg0) throws DOMException {
		return ref.appendChild( arg0 );
	}

	public boolean hasChildNodes() {
		return ref.hasChildNodes();
	}

	public Node cloneNode(boolean arg0) {
		return ref.cloneNode( arg0 );
	}

	public void normalize() {
		ref.normalize();
	}

	public boolean isSupported(String arg0, String arg1) {
		return ref.isSupported( arg0, arg1 );
	}

	public String getNamespaceURI() {
		return ref.getNamespaceURI();
	}

	public String getPrefix() {
		return ref.getPrefix();
	}

	public void setPrefix(String arg0) throws DOMException {
		ref.setPrefix( arg0 );
	}

	public String getLocalName() {
		return ref.getLocalName();
	}

	public boolean hasAttributes() {
		return ref.hasAttributes();
	}

	public String getBaseURI() {
		return ref.getBaseURI();
	}

	public short compareDocumentPosition(Node arg0) throws DOMException {
		return ref.compareDocumentPosition( arg0 );
	}

	public String getTextContent() throws DOMException {
		return ref.getTextContent();
	}

	public void setTextContent(String arg0) throws DOMException {
		ref.setTextContent( arg0 );
	}

	public boolean isSameNode(Node arg0) {
		return ref.isSameNode( arg0 );
	}

	public String lookupPrefix(String arg0) {
		return ref.lookupPrefix( arg0 );
	}

	public boolean isDefaultNamespace(String arg0) {
		return ref.isDefaultNamespace( arg0 );
	}

	public String lookupNamespaceURI(String arg0) {
		return ref.lookupNamespaceURI( arg0 );
	}

	public boolean isEqualNode(Node arg0) {
		return ref.isEqualNode( arg0 );
	}

	public Object getFeature(String arg0, String arg1) {
		return ref.getFeature( arg0, arg1 );
	}

	public Object setUserData(String arg0, Object arg1, UserDataHandler arg2) {
		return ref.setUserData( arg0, arg1, arg2 );
	}

	public Object getUserData(String arg0) {
		return ref.getUserData( arg0 );
	}

}
