package com.japisoft.multipanes;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface TitledPaneModel {

	/** Add a new titledPane component */
	public void addTitledPane( TitledPane tp );
	
	/** Remove a previously inserted component */
	public void removeTitledPane( TitledPane tp );

	/** Insert a titledPane at a specific location */
	public void insertTitledPane( int index, TitledPane tp );

	/** @return a titledPane matching the parameter name */
	public TitledPane getTitledPaneByName( String name );

	/** @return the number of titledPane */
	public int getTitledPaneCount();
	
	/** @return a titledPane for a location starting at 0 */
	public TitledPane getTitledPaneAt( int location );
	
	/** @return the index of the titledPane starting at 0 */
	public int getTitledPaneIndex( TitledPane tp );
}
