package com.japisoft.p3;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public final class WrongUserController {
	
	static ArrayList DEAD_ZONE = new ArrayList();

	static {
		DEAD_ZONE.add( "Doi La Phu Du" );
		DEAD_ZONE.add( "Malaika D. Maddox" );

		try {
			InputStream input = ClassLoader.getSystemResourceAsStream( "users.dea" );
			BufferedReader reader = new BufferedReader(
					new InputStreamReader( input ) );
			try {
				
				ApplicationModel.debug( "Using users.dea" );				
				
				String line = null;
				int forMajorVersion = -1;
				while ( ( line = reader.readLine() ) != null ) {
					if ( line.startsWith( "-" ) ) {
						forMajorVersion = Integer.parseInt( line.substring( 1 ) );
					} else
						if ( forMajorVersion == ApplicationModel.MAJOR_VERSION ) {
							DEAD_ZONE.add( line );
						}

				}
			} finally {
				reader.close();
			}
		} catch( Throwable th ) {
		}
	}

	public static void addToDeadZone( String user ) {
		DEAD_ZONE.add( user );
	}

	static void control(String user) {
		if ( DEAD_ZONE.contains( user ) ) {
			throw new RuntimeException( "Wrong user" );
		}
	}

}
