package com.japisoft.sc;

import java.awt.*;
import java.util.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class CollectionTokenMatcher extends TokenMatcher {

  private TokenMatcher[] tm;
  private Hashtable collection;
  private String name;
  private TokenMatcher[] tm2;

  public CollectionTokenMatcher( Hashtable collection, String name ) {
    this.collection = collection;
    this.name = name;
  }

  public CollectionTokenMatcher( TokenMatcher[] tm ) {
    this.tm2 = tm;
  }

  public TokenMatcher[] getNext(char current) {
    // Check if one caracter is inside the collection
    if ( tm == null && tm2 == null )
      tm = new TokenMatcher[] { new CollectionTokenMatcher( tm2 = ( TokenMatcher[] )collection.get( name ) ) };
    for ( int i = 0; i < tm2.length; i++ ) {
      if ( tm2[ i ].getNext( current ) != null ) {
        Color c = tm2[ i ].getToken().getColor();
        this.t = tm2[ i ].getToken();
        System.out.println( c.getRed() + "," + c.getGreen() + "," + c.getBlue() );
        return new TokenMatcher[] { this };
      }
    }
    return null;
  }
}
