package com.japisoft.stylededitor.ui.node;

import com.japisoft.stylededitor.EditorByCSS;
import com.japisoft.stylededitor.model.DocumentElement;
import com.japisoft.stylededitor.model.NodeElement;
import com.japisoft.stylededitor.model.TextElement;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ElementViewFactory {

	private static ElementViewFactory INSTANCE = null;
	
	private ElementViewFactory() {
		super();
	}
	
	public static ElementViewFactory getInstance() {
		if ( INSTANCE == null )
			INSTANCE = new ElementViewFactory();
		return INSTANCE;
	}

	private DocumentElementView defaultRootView = null;
	private TextElementView defaultTextView = null;
	private NodeElementView defaultNodeView = null;

	private ElementView defaultNodeView2 = null;

	public ElementView getView( EditorByCSS editor, NodeElement element ) {
		if ( element instanceof TextElement ) {
			if ( defaultTextView == null )
				defaultTextView = new TextElementView();
			return defaultTextView;
		} else
		if ( element instanceof DocumentElement ) {
			if ( defaultRootView == null )
				defaultRootView = new DocumentElementView();
			return defaultRootView;
		} else {
			if ( defaultNodeView == null )
				defaultNodeView = new NodeElementView();

			if ( editor.displayTag() ) {
				if ( defaultNodeView2 == null )
					defaultNodeView2 = new NodeElementViewProxy( defaultNodeView );
				return defaultNodeView2;
			}

			return defaultNodeView;
		}
	}

}
