package com.japisoft.xflows.action.options.tasks;

import java.awt.event.ActionEvent;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;

import javax.swing.AbstractAction;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xflows.task.ui.XFlowsFactory;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TaskConfigAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {
		
		TasksConfigPanel panel = new TasksConfigPanel(); 
		
		if ( DialogManager.showDialog(
				ApplicationModel.MAIN_FRAME,
				"Tasks manager",
				"Tasks manager",
				"Manage your own XFlows Task here",
				null,
				panel ) ==
					DialogManager.OK_ID ) {

			FPNode node = panel.getRootNode();
			URL documentUrl = ClassLoader.getSystemClassLoader().getResource( "tasks.xml" );

			try {
				String fileName = documentUrl.toExternalForm();
				fileName = fileName.replaceAll("%20", " ");
				fileName = fileName.substring(5);				
				node.getDocument().write( new FileOutputStream( fileName ) );
				XFlowsFactory.buildAndShowInformationDialog( "Restart XFlows for using the new tasks" );
			} catch (IOException e1) {
				XFlowsFactory.buildAndShowErrorDialog( "Can't write tasks.xml : " + e1.getMessage() );
			}
		}
	}

}
