package com.japisoft.xflows.task.imp.cvs;

import java.io.FileWriter;
import java.io.IOException;

import com.japisoft.framework.xml.imp.CSVImport;
import com.japisoft.xflows.task.TaskContext;
import com.japisoft.xflows.task.TaskRunner;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CSVFileRunner implements TaskRunner {

	public boolean run( TaskContext context ) {
		context.addInfo( "Importing " + context.getCurrentSourceFile() );

		CSVImportParamsImpl params = 
			new CSVImportParamsImpl( context.getParams() );

		try {
			String buffer = CSVImport.impCSV(
					context.getCurrentSourceFile(),
					params );
			FileWriter writer = new FileWriter( context.getCurrentTargetFile() );
			try {
				writer.write( buffer );
			} finally {
				writer.close();
			}
		} catch (IOException e) {
			context.addError( e.getMessage() );
			return TaskRunner.ERROR;
		}

		return TaskRunner.OK;
	}

}
