package com.japisoft.xflows.task.imp.cvs;

import java.util.StringTokenizer;

import javax.swing.DefaultListModel;
import javax.swing.ListModel;

import com.japisoft.framework.xml.imp.CSVImportParams;
import com.japisoft.xflows.task.TaskParams;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CSVImportParamsImpl implements CSVImportParams {

	private TaskParams params;
	
	public CSVImportParamsImpl(
			TaskParams params ) {
		this.params = params;
	}

	public ListModel getColumnName() {
		DefaultListModel model = new DefaultListModel();
		String colNameVal = params.getParamValue( CSVParametersDialog.COLNAME_KEY );
		if ( colNameVal != null ) {
			StringTokenizer st = new StringTokenizer( colNameVal, "@@" );
			while ( st.hasMoreTokens() ) {
				model.addElement( st.nextToken() );
			}
		}		
		return model;
	}

	public String getOther() {
		return params.getParamValue( CSVParametersDialog.OTHERVAL_KEY );
	}

	public String getRowName() {
		return params.getParamValue( CSVParametersDialog.ROWNAME_KEY );
	}

	public int getStartingRow() {
		return params.getParamValueInteger( CSVParametersDialog.STARTINGROW_KEY );
	}

	public String getTextQualifier() {
		return params.getParamValue( CSVParametersDialog.TEXTQUALIF_KEY );
	}

	public boolean isCommaSelected() {
		return params.getParamValueBoolean( CSVParametersDialog.COMMA_KEY );
	}

	public boolean isOtherSelected() {
		return params.getParamValueBoolean( CSVParametersDialog.OTHER_KEY );
	}

	public boolean isSemiColonSelected() {
		return params.getParamValueBoolean( CSVParametersDialog.SEMICOL_KEY );
	}

	public boolean isSpaceSelected() {
		return params.getParamValueBoolean( CSVParametersDialog.SPACE_KEY );
	}

	public boolean isTabSelected() {
		return params.getParamValueBoolean( CSVParametersDialog.TAB_KEY );
	}

}
