package com.japisoft.xflows.task.ui.runner;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.SwingUtilities;

import com.japisoft.framework.dockable.action.ActionModel;
import com.japisoft.xflows.task.TaskTable;
import com.japisoft.xflows.task.ui.XFlowsFactory;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TasksPanel extends JPanel {

	private RunnerAction action;
	
	public TasksPanel( RunnerAction action ) {
		super();
		init();
		this.action = action;
	}

	TaskTable table;

	private void init() {
		setLayout( new BorderLayout() );
		add( new JScrollPane( 
				table = new TaskTable( null, false ) ), 
				BorderLayout.CENTER );
/*JToolBar tb = new JToolBar();
		add( tb, BorderLayout.NORTH );
		tb.add( new RunAction() );
		tb.add( stopAction = new StopAction() ); */
	}

	void fillActionModel( ActionModel model ) {
		model.addAction( new StopAction() );
		model.addAction( new RunAction() );
	}

	Action stopAction = null;

	//////////////////////////////////////////////////////////
	
	class RunAction extends AbstractAction {
		public RunAction() {
			super();
			//putValue( Action.NAME, "Run" );
			putValue( Action.SMALL_ICON, XFlowsFactory.getImageIcon( "images/element_run.png" ) );
			putValue( Action.SHORT_DESCRIPTION, "Run the scenario" );
		}
		public void actionPerformed( ActionEvent e ) {
			SwingUtilities.invokeLater( 
					new Runnable() {
						public void run() {
							action.run();
					}
			} );
		}
	}

	class StopAction extends AbstractAction {
		public StopAction() {
			super();
			//putValue( Action.NAME, "Stop" );
			putValue( Action.SMALL_ICON, XFlowsFactory.getImageIcon( "images/element_stop.png" ) );
			putValue( Action.SHORT_DESCRIPTION, "Stop the scenario" );
		}

		public void actionPerformed( ActionEvent e ) {
			action.stop();
		}
	}

}
