package com.japisoft.xmlform.designer.library;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.TransferHandler;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ListDragDrop extends TransferHandler implements
		MouseMotionListener {

	private JList list = null;

	public ListDragDrop( JList list ) {
		this.list = list;
		list.setDragEnabled( true );		
		list.setTransferHandler( this );
		list.addMouseMotionListener( this );

	}

	public void mouseDragged(MouseEvent e) {
		exportAsDrag( list, e, TransferHandler.MOVE );
	}

	public void mouseMoved(MouseEvent e) {}

	private ComponentDescriptor descriptor = null;
	
	public void exportAsDrag(
			JComponent comp, 
			InputEvent e, 
			int action ) {
		descriptor = ( ComponentDescriptor )list.getSelectedValue();
		super.exportAsDrag( comp, e, action );
	}

	@Override
	public boolean canImport(JComponent comp, DataFlavor[] transferFlavors) {
		return false;
	}

	@Override
	protected Transferable createTransferable(JComponent c) {
		if ( descriptor != null )
			return new StringSelection( "new:" + descriptor.getName() );
		else
			return super.createTransferable( c );
	}

	@Override
	public int getSourceActions(JComponent c) {
		return TransferHandler.MOVE;
	}

}
