package com.japisoft.xmlform.designer.properties;

import java.util.List;

import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class PropertiesModel implements TableModel {

	private List<PropertyDescriptor> data = null;
	
	public void init( List<PropertyDescriptor> descriptors ) {
		this.data = descriptors;
		l.tableChanged( new TableModelEvent( this ) );
	}

	private TableModelListener l;

	public void addTableModelListener(TableModelListener l) {
		this.l = l;
	}

	public Class<?> getColumnClass(int columnIndex) {
		return String.class;
	}

	public int getColumnCount() {
		return 2;
	}

	public String getColumnName(int columnIndex) {
		if ( columnIndex == 0 )
			return "Name";
		return "Value";
	}

	public int getRowCount() {
		if ( data == null )
			return 0;
		else
			return data.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		PropertyDescriptor pd = 
			data.get( rowIndex );
		if ( columnIndex == 0 )
			return pd.getName();
		else
			return pd.getValue();
	}
	
	public PropertyDescriptor getPropertyAt( int rowIndex ) {
		return data.get( rowIndex );
	}

	public boolean isCellEditable(int rowIndex, int columnIndex) {
		if ( columnIndex == 0 )
			return false;
		return true;
	}

	public void removeTableModelListener(TableModelListener l) {
		this.l = null;
	}

	public void setValueAt(Object value, int rowIndex, int columnIndex) {
		PropertyDescriptor pd = 
			data.get( rowIndex );
		if ( columnIndex == 1 )
			pd.setValue( value );		
	}

}
