package com.japisoft.xmlform.designer.properties.descriptors;

import java.awt.Component;
import java.awt.Rectangle;

import com.japisoft.xmlform.designer.properties.VirtualPropertyDescriptor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class HeightPropertyDescriptor extends VirtualPropertyDescriptor {
	
	public HeightPropertyDescriptor( Component source ) {
		super( 
			source, 
			"height", 
			Integer.class, 
			source.getHeight()
		);
	}

	public void setValue( Object value ) {
		this.value = value;
		Rectangle r = source.getBounds();
		r.height = ( Integer )value;
		source.setBounds( r );
	}

}
