package com.japisoft.xmlform.designer.properties.editors;

import java.awt.Component;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import com.japisoft.xmlform.designer.properties.PropertyEditor;
import com.japisoft.xmlform.designer.properties.PropertyEditorListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FontEditor extends JButton implements 
		PropertyEditor, ActionListener {

	public FontEditor() {
		setText( "Font..." );
	}

	@Override
	public void addNotify() {
		super.addNotify();
		addActionListener( this );
	}

	@Override
	public void removeNotify() {
		super.removeNotify();
		removeActionListener( this );
	}
	
	private Font currentFont = null;
	
	public Object getValue() {
		return currentFont;
	}

	public Component getView() {
		return this;
	}

	public void actionPerformed(ActionEvent e) {
		Font f = FontChooser.showFontChooser( this, "Choose your font", currentFont );
		if ( f == null ) {
			listener.cancel();
		} else {
			currentFont = f;
			listener.stop();
		}
	}

	private PropertyEditorListener listener = null;
	
	public void setPropertyEditorListener(PropertyEditorListener listener) {
		this.listener = listener;
	}

	public void setSelected(boolean selected) {
	}

	public void setValue(Object value) {
		currentFont = ( Font )value;
	}

}
