package com.japisoft.xmlform.designer.properties.editors;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JTextField;

import com.japisoft.xmlform.designer.properties.PropertyEditor;
import com.japisoft.xmlform.designer.properties.PropertyEditorListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TextEditor extends JTextField 
		implements 
			PropertyEditor, 
			ActionListener {

	public static final int STRING_TYPE = 0;
	public static final int INT_TYPE = 1;
	
	private int type = STRING_TYPE;

	public TextEditor() {
		super();
	}

	public TextEditor( int type ) {
		this();
		this.type = type;
	}
	
	@Override
	public void addNotify() {
		super.addNotify();
		addActionListener( this );
	}

	@Override
	public void removeNotify() {
		super.removeNotify();
		removeActionListener( this );
	}
	
	public void actionPerformed(ActionEvent e) {
		listener.stop();
	}

	public Object getValue() {
		if ( type == INT_TYPE ) {
			try {
				return Integer.parseInt( 
						getText() );
			} catch ( NumberFormatException e ) {
				listener.cancel();
				return 0;
			}
		} else		
			return getText();
	}

	public Component getView() {
		return this;
	}

	private PropertyEditorListener listener = null;
	
	public void setPropertyEditorListener(PropertyEditorListener listener) {
		this.listener = listener;
	}

	public void setSelected( boolean selected ) {
	}

	public void setValue( Object value ) {
		if ( type == INT_TYPE ) {
			setText( value.toString() );
		} else
		setText( (String)value );
	}

}
