package com.japisoft.xmlform.editor;

import org.apache.xerces.jaxp.DocumentBuilderImpl;
import org.apache.xerces.jaxp.SAXParserFactoryImpl;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.internationalization.Traductor;
import com.japisoft.framework.preferences.Preferences;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditorModel extends ApplicationModel {

	static {
		Preferences.PREF_FILENAME = "pref-xfe1.prop";
		EditorModel.LONG_APPNAME = "XML Form Editor";
		EditorModel.SHORT_APPNAME = "xmlformeditor";
		EditorModel.BUILD = "220908";
		EditorModel.BETA_VERSION = 0;
		EditorModel.MAJOR_VERSION = 1;
		EditorModel.MINOR_VERSION = 0;
		EditorModel.SUBMINOR_VERSION = 0;
		EditorModel.MAIN_SUPPORT_EMAIL = "jsupport@japisoft.com";
		EditorModel.REGISTERED_FILE = "xf1.reg";
		EditorModel.USERINTERFACE_FILE = "xfe.xml";	
		
		System.getProperty( 
				"javax.xml.parsers.DocumentBuilderFactory", 
				DocumentBuilderImpl.class.getName() );
		
		System.getProperty( 
				"javax.xml.parsers.SAXParserFactory",
				 SAXParserFactoryImpl.class.getName() );
		
	}

	public EditorModel( String[] args ) {

		System.out.println( "Check language" );
		
		boolean ok = false;
		
		for ( int i = 0; i < args.length; i++ ) {
			if ( "-l".equals( args[ i ] ) ) {
				if ( i < args.length -1 ) {
					Traductor.setTraductor( args[ i + 1 ] );
					System.out.println( "Found " + args[ i + 1 ] );
					ok = true;
				}
				break;
			}
		}
		
	}

	// Loaded document
	public static String CURRENT_DOCUMENT = null;

	public static EditorFrame getEditorFrame() {
		if ( EditorModel.MAIN_FRAME instanceof EditorFrame )
			return ( EditorFrame )EditorModel.MAIN_FRAME;
		return null;
	}

	public static String SPELL_CHECK = null;

}
