package com.japisoft.xmlform.editor.actions.edit;

import java.awt.Component;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.FocusManager;

import com.japisoft.xmlform.component.AbstractXMLFormComponent;
import com.japisoft.xmlform.component.editable.XMLFormTextComponent;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public abstract class EditAction extends AbstractAction {

	private AbstractXMLFormComponent getAncestor( Component c ) {
		if ( c == null )
			return null;		
		if ( c instanceof AbstractXMLFormComponent )
			return ( AbstractXMLFormComponent )c;
		return getAncestor( c.getParent() );
	}

	protected AbstractXMLFormComponent getCurrentComponent() {
		Component c = 
			FocusManager.getCurrentManager().getPermanentFocusOwner();

		c = getAncestor( c );
		
		if ( c instanceof AbstractXMLFormComponent )
			return ( AbstractXMLFormComponent )c;
		return null;
	}

	public void actionPerformed( ActionEvent e ) {
		AbstractXMLFormComponent component = 
			getCurrentComponent();
		if ( component instanceof XMLFormTextComponent )
			actionPerformed2( ( XMLFormTextComponent )component );
	}	

	public abstract void actionPerformed2( XMLFormTextComponent component );

}
