package com.japisoft.xmlform.editor.step;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Toolkit;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.ApplicationStepAdapter;
import com.japisoft.framework.preferences.Preferences;
import com.japisoft.xmlform.editor.EditorFrame;
import com.japisoft.xmlform.editor.EditorModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FrameBuildingStep extends ApplicationStepAdapter {

	@Override
	public void start(String[] args) {

		EditorFrame frame = null;
		frame = new EditorFrame( ApplicationModel.INTERFACE_BUILDER );
		EditorModel.MAIN_FRAME = frame;

		Rectangle r = Preferences.getPreference( 
				"dialog", 
				"frame",
				new Rectangle( 0, 0, 0, 0 ) );

		if ( !((r.x == r.y) && (r.width == r.height) && (r.x == 0)))
			frame.setBounds( r );
		else {
			frame.setLocation( 0, 0 );
			Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
			frame.setSize( dim.width, dim.height - 30 );
		}

		frame.initUI();
		frame.setVisible( true );

		if ( args.length > 0 ) {
			
			try {

				if ( args[ 0 ].toLowerCase().endsWith( ".xf" ) ) {
					
					frame.newDocument( args[ 0 ] );

					if ( args.length > 1 ) {
						EditorModel.CURRENT_DOCUMENT = args[ 1 ];					
					}
					
				} else {
					
					frame.loadDocument( args[ 0 ] );

					if ( args.length > 1 ) {
						EditorModel.CURRENT_DOCUMENT = args[ 1 ];
					}

				}

			} catch ( Exception e ) {
				
				e.printStackTrace();

			}

		}
		
	}
	
}
