package com.japisoft.xmlpad;

import java.io.IOException;
import java.io.Reader;
import java.io.Writer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface Accessibility {

	/** Reset the editing content. It should be a full XML document */
	public void setText( String text );

	/** @return the current editing content */
	public String getText();

	/** Reset the editing content using this reader */
	public void read( Reader reader ) throws IOException;

	/** Reset this writer with the editing content */
	public void write( Writer writer ) throws IOException;

	/** Call an XML action. Look at the <code>ActionModel</code> for action name
	 * @return XMLAction.VALID_ACTION when the action has been done without error */
	public boolean invokeAction( String actionName );

	/** This is only for inner usage, it mustn't be called by the user */
	void dispose();
}
