package com.japisoft.xmlpad;

import java.net.URL;

import com.japisoft.framework.xml.SchemaLocator;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class BasicSchemaAccessibility implements SchemaAccessibility {

	XMLContainer container = null;
	
	public BasicSchemaAccessibility( XMLContainer container ) {
		this.container = container;
	}
	
	public String getCurrentDTD() {
		return container.getCurrentDTD();
	}

	public String getCurrentDTDRoot() {
		return container.getCurrentDTDRoot();
	}

	public String getCurrentSchema() {
		return container.getCurrentSchema();
	}

	public String getCurrentSchemaRoot() {
		return container.getCurrentSchemaRoot();
	}

	public String getDefaultDTDLocation() {
		return container.getDefaultDTDLocation();
	}

	public String getDefaultDTDRoot() {
		return container.getDefaultDTDRoot();
	}

	public String getDefaultSchemaLocation() {
		return container.getDefaultSchemaLocation();
	}

	public String getDefaultSchemaRoot() {
		return container.getDefaultSchemaRoot();
	}

	public String getDTDLocation(boolean resolve) {
		return container.getDTDLocation(resolve);
	}

	public SchemaLocator getRelaxNGValidationLocation() {
		return container.getRelaxNGValidationLocation();
	}

	public String getSchemaLocation(boolean resolve) {
		return container.getSchemaLocation(resolve);
	}

	public void setDefaultDTD(String dtdRoot, String dtd) {
		container.setDefaultDTD(dtdRoot, dtd);
	}

	public void setDefaultDTD(String dtdRoot, URL dtd) {
		container.setDefaultDTD(dtdRoot, dtd);
	}

	public void setDefaultSchema(String root, String location) {
		container.setDefaultSchema(root, location);
	}

	public void setDTD(String dtdRoot, String dtdLocation, int dtdDeclarationLine ) {
		container.setDTD(dtdRoot, dtdLocation, dtdDeclarationLine );
	}

	public void setDTD( String dtdRoot, SchemaLocator locator ) throws Exception {
		container.setDTD( dtdRoot, locator );
	}

	public void setRelaxNGValidationLocation(String location) {
		container.setRelaxNGValidationLocation(new SchemaLocator(
				location));
	}

	public void setRelaxNGValidationLocation(SchemaLocator locator) {
		container.setRelaxNGValidationLocation(locator);
	}

	public void setSchema( String schemaRoot, String[] namespace, String[] schemaLocation, int schemaDeclaration ) {
		container.setSchema( schemaRoot, namespace, schemaLocation, schemaDeclaration );
	}

	/** This is only for inner usage, it mustn't be called by the user */
	public void dispose() {
		this.container = null;
	}
}
