package com.japisoft.xmlpad;

import java.util.EventObject;

import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class LocationEvent extends EventObject {
	private FPNode location;
	private Object source;

	public LocationEvent( Object source, FPNode location ) {
		super( source );
		this.location = location;
	}

	private LocationEvent() {
		super( null );
	}

	private static LocationEvent singleton = null;
	
	
	public static LocationEvent getSharedInstance( Object source, FPNode location ) {
		if ( singleton == null )
			singleton = new LocationEvent();
		singleton.location = location;
		singleton.source = source;
		return singleton;
	}

	public Object getSource() { return source;
	}

	/** @return a node from the current document for the caret position. This method
	 * may return <code>null</code> */ 
	public FPNode getDocumentLocation() { return location; }

	/** @return the current XPath location. This method can return an empty string "" */
	public String getXPathLocation() { 
		if ( location != null )
			return location.getCachedXPathLocation();
		return "";
	}

}
