package com.japisoft.xmlpad;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XMLDocumentFileFilter extends FileFilter {
	
	private String[] fileExts;
	private String def;
	private String name;
	private String type;
	
	public XMLDocumentFileFilter( 
			String name, 
			String type, 
			String[] fileExts, 
			String def ) {
		this.fileExts = fileExts;
		this.def = def;
		this.name = name;
		this.type = type;
	}
	
	public String getDescription() {
		StringBuffer sb = new StringBuffer();
		for ( int i = 0; i < fileExts.length; i++ ) {
			if ( i > 0 )
				sb.append( " " );
			sb.append( "*." ).append( fileExts[ i ] );
		}
		return name + " (" + sb.toString() + ")";		
	}
	
	public boolean accept(File f) {
		if (f.isDirectory())
			return true;
		if ( f.toString() == null )
			return false;
		String sf = f.toString().toLowerCase();
		if (fileExts == null)
			return sf.endsWith( def );
		for (int i = 0; i < fileExts.length; i++) {
			if (sf.endsWith(fileExts [i ].toString()))
				return true;
		}
		return false;	
	}

	public String getType() {
		return type;
	}
	
}
