package com.japisoft.xmlpad.bookmark;

import javax.swing.text.Position;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BookmarkPosition implements Position {

	Object source;
	Position position;
	Object highlightFlag;
		
	/** Initialize this bookmark position
	 * @param position must not be <code>null</code> */
	public BookmarkPosition( Position position, Object highlightFlag ) {
		this.position = position;
		this.highlightFlag = highlightFlag;
	}
	
	/** @return the current bookmark position */
	public int getOffset() {
		return position.getOffset();
	}
	
	/** @return a flag for this highlight. This is for inner usage */
	public Object getHighlightFlag() {
		return this.highlightFlag;
	}

	public void setSource( Object source ) {
		this.source = source;
	}
	
	public Object getSource() {
		return source;
	}
	
	public void dispose() {
		this.source = null;
	}

}
