package com.japisoft.xmlpad.editor;

import java.awt.Color;

import javax.swing.text.Element;
import javax.swing.text.PlainView;
import javax.swing.text.Segment;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CommonView extends PlainView implements XMLViewable {

	protected LineParsing lp;

	protected Segment line;

	public CommonView(Element elem) {
		super(elem);
		line = new Segment();
		lp = new LineParsing();
	}

	protected ViewPainterListener painterListener;
	
	public void setViewPainterListener( ViewPainterListener listener ) {
		this.painterListener = listener;
	}

	protected boolean visibleSpace = false; 
	
	public void setDisplaySpace( boolean visibleSpace ) {
		this.visibleSpace = visibleSpace;
	}
	
	protected Color darker(Color c) {
		return new Color(Math.max((int) (c.getRed() * 0.8), 0), Math.max(
				(int) (c.getGreen() * 0.8), 0), Math.max(
				(int) (c.getBlue() * 0.8), 0));
	}

	public void setSyntaxColor(boolean enabled) {
		if (!enabled)
			lp = null;
	}
	
	public void setDTDMode(boolean enabled) {
		// IGNORED
	}	

}
