package com.japisoft.xmlpad.editor;

import javax.swing.text.BadLocationException;

import com.japisoft.xmlpad.editor.XMLEditor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ExpressionHighlighterManager {

	public static void highlight( XMLEditor editor ) {

		// Remove the previous one
		editor.removeHighlightExpression();

		try {
			String part = 
				editor.getText( editor.getCaretPosition(), 1 );
			char c = 
				part.charAt( 0 );
			
			int searchDirection = +1;
			char o = 0;

			boolean beginPart = ( c == '<' || c == '(' || c == '{' || c == '[' );
			if ( !beginPart ) {
				part = editor.getText( editor.getCaretPosition() - 1, 1 );
				c = part.charAt( 0 );
			}
			boolean endPart = ( c == '>' || c == ')' || c == '}' || c == ']' );
			
			int location = editor.getCaretPosition();
						
			if ( endPart ) {
				searchDirection = -1;
				if ( c == '>' )
					o = '<';
				else
				if ( c == ')' )
					o = '(';
				else
				if ( c == '}' )
					o = '{';
				else
				if ( c == ']' )
					o = '[';
				location--;
			} else
			if ( beginPart ) {
				if ( c == '<' )
					o = '>';
				else
				if ( c == '(' )
					o = ')';
				else
				if ( c == '{' )
					o = '}';
				else
				if ( c == '[' )
					o = ']';
				location++;
			} else
				return;	// Nothing to check

			int counter = 0;

			for ( int i = 0; i < 1000; i++ ) {
				
				location += searchDirection;
				String tmp = 
					editor.getText( location, 1 );
				
				if ( tmp.charAt( 0 ) == c ) {
					counter++;
				}
				
				if ( tmp.charAt( 0 ) == o ) {
					if ( counter == 0 ) {
						
						editor.highlightExpression( location );
						
						break;
					}
					counter--;
				}
				
			}
			
		} catch ( BadLocationException e ) {
		}
		
	}

}
