package com.japisoft.xmlpad.editor.renderer;

import java.awt.Color;
import java.awt.Graphics;

import com.japisoft.xmlpad.editor.renderer.LineRenderer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditixLineRenderer implements LineRenderer {

	static EditixLineRenderer singleton = null;
	
	public static LineRenderer getSharedInstance() {
		if ( singleton == null )
			singleton = new EditixLineRenderer();
		return singleton;
	}

	private EditixLineRenderer() {
	}

	public void renderer(
		Graphics gc,
		Color color,
		int x,
		int y,
		int width,
		int height) {
		gc.setColor( color );
		for ( int i = 0; i < width; i += 4 ) {
			gc.drawLine( x + i, y + height, x + i + 2, y + height );
			gc.drawLine( x + i + 2, y + 1 + height, x + i + 4, y + 1 + height );
		}
	}

}
