package com.japisoft.xmlpad.error;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface ErrorListener {

	/** This is called once before checking the whole document */
	public void initErrorProcessing();

	/** This is called once after checking the whole document */
	public void stopErrorProcessing();
	
	/** Notify an XML error found while parsing
	 * @param context the error context, it can be <code>null</code> and may be ignored
	 * @param localError a flag for knowing if the error is inside the current document (sometimes this is inside a DTD or a W3C Schema)
	 * @param sourceLocation The document location
	 * @param line The error line
	 * @param col The error column
	 * @param offset The error offset
	 * @param message The error message
	 * @param onTheFly Flag for informing if this is while the user inserts or no */
    public void notifyError(
    		Object context,
    		boolean localError,
    		String sourceLocation, 
			int line, 
			int 
			col, 
			int offset, 
			String message, 
			boolean onTheFly );

    /** Notify the document is correct
     * @param onTheFly for informing if this is while inserting characters */
    public void notifyNoError( boolean onTheFly );

}

// ErrorListener ends here
