package com.japisoft.xmlpad.error;

import javax.swing.JComponent;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface ErrorView extends ErrorListener {
	
	/** It must always return the same view object. Don't create
	 * a new object for this method return */
	public JComponent getView();
	
	/**
	 * @return <code>true</code> if the error panel is shown for onTheFly error (while inserting characters) */
	public boolean isShownForOnTheFly();
	
	/** Add a selection listener for listening error choosen */
	public void addErrorSelectionListener( ErrorSelectionListener listener );

	/** Remove a selection listener for listening error not choosen */
	public void removeErrorSelectionListener( ErrorSelectionListener listener );

	/** Call when the view is not be used more. Useful for freeing some memory parts */
	public void dispose();
	
	/** Call whent the error view has been added */
	public void initOnceAdded();
}
