package com.japisoft.xmlpad.helper.handler.schema;

import javax.swing.Icon;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.SharedProperties;
import com.japisoft.xmlpad.editor.XMLPadDocument;
import com.japisoft.xmlpad.helper.SchemaHelperManager;
import com.japisoft.xmlpad.helper.handler.AbstractHelperHandler;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public abstract class AbstractEntityHandler extends AbstractHelperHandler {

	protected String getActivatorSequence() {
		return "&";
	}	

	public boolean haveDescriptors(
			FPNode currentNode,
			XMLPadDocument document,
			boolean insertBefore, 
			int offset, 
			String activatorString) {

		if ( activatorString != null && 
				!"&".equals( activatorString ) )
			return false;
		
		if ( currentNode == null )
			return false;
		
		if ( activatorString == null ) {
			if ( document.isInsideTagExceptAttributeValue( offset ) )
				return false;
		}
		
		return match( 
				document, 
				offset, 
				activatorString, 
				"&" );
	}

	protected Icon getDefaultIcon() {
		return SharedProperties.getDefaultEntityHelperIcon();
	}

	public String getName() {
		return SchemaHelperManager.SCHEMA_ENTITIES;
	}	
	
	public String getType() {
		return SchemaHelperManager.ENTITY_TYPE;
	}	
	
	public String getTitle() {
		return "Entities";
	}

}
