package com.japisoft.xmlpad.helper.model;

import java.awt.Color;

import javax.swing.Action;
import javax.swing.Icon;
import com.japisoft.xmlpad.helper.handler.AbstractHelperHandler;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public abstract class AbstractDescriptor implements Descriptor {

	public boolean startsWith(String sequence) {
		if ( sequence == null )
			return false;
		String name = getName();
		return name != null && name.startsWith( sequence );
	}

	private String sequence;
	
	public void setSequence(String sequence) {
		this.sequence = sequence;
	}
	
	public String getSequence() {
		return sequence;
	}

	private String comment = null;

	public void setComment( String comment ) {
		this.comment = comment;
	}
	
	public String getComment() {
		return comment;
	}

	private Icon icon = null;
	protected String addedPart = null;

	public Icon getIcon() {
		return icon;
	}

	public void setIcon( Icon icon ) {
		this.icon = icon;
	}
	
	protected Color color;
	
	public void setColor( Color color ) {
		this.color = color;
	}

	public Color getColor() {
		return color;
	}
	
	public void setAddedPart( String added ) {
		this.addedPart = added;
	}

	private AbstractHelperHandler source;

	public void setSource( AbstractHelperHandler source ) {
		this.source = source;
	}

	public AbstractHelperHandler getSource() {
		return source;
	}

	public void dispose() {
		this.source = null;
	}	

	private boolean autoNext = false;
	
	public void setAutomaticNextHelper( boolean next ) {
		this.autoNext = next;
	}
	
	public boolean hasAutomaticNextHelper() {
		return autoNext;
	}
	
	protected String type;
	
	public void setType( String type ) { 
		this.type = type;
	}
	
	public String getType() {
		return type;
	}	

	private Action a;
	
	public Action getSpecificAction() {
		return a;
	}

	public void setSpecificAction( Action a ) {
		this.a = a;
	}

}
