package com.japisoft.xmlpad.helper.model;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CommonPopup extends JPopupMenu implements ChangeListener {

	public CommonPopup( String title ) {
		super( title );	
		setBackground( Color.WHITE );
		setForeground( Color.BLACK );
		setBorderPainted( true );
	}
	
	protected JMenuItem getMenuItem() {
		JMenuItem item = new JMenuItem();
		item.setBackground( Color.WHITE );
		item.setFont( new Font( "arial", Font.PLAIN, 12 ) );
		item.addChangeListener( this );
		return item;
	}

	protected void firePopupMenuWillBecomeInvisible() {
		super.firePopupMenuWillBecomeInvisible();
		if ( lastSelection > -1 )
			notifySelection( lastSelection );	
		removeListeners();
	}
		
	private void removeListeners() {
		for ( int i = 0; i < getComponentCount(); i++ ) {
			if ( getComponent( i ) instanceof JMenuItem ) {
				( ( JMenuItem )getComponent( i ) ).removeChangeListener( this );
			}
		}
	}

	private int lastSelection = 0;

	/* (non-Javadoc)
	 * @see javax.swing.event.ChangeListener#stateChanged(javax.swing.event.ChangeEvent)
	 */
	public void stateChanged(ChangeEvent e) {
		lastSelection = getComponentIndex( ( Component )e.getSource() );
	}

	protected void notifySelection( int selection ) {
	}

}
