package com.japisoft.xmlpad.helper.model;

import javax.swing.JMenuItem;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;

import com.japisoft.xmlpad.editor.XMLPadDocument;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TagPopup extends CommonPopup {
	protected TagDescriptor[] tags;
	private int offset;
	private Document doc;

	public TagPopup(TagDescriptor[] tags, int offset, Document doc) {
		super("Elements");
		this.tags = tags;
		this.offset = offset;
		this.doc = doc;
		buildit();
	}

	protected void buildit() {
		for (int i = 0; i < tags.length; i++) {
			add(buildMenuItem(tags[i]));
		}
	}

	protected JMenuItem buildMenuItem(TagDescriptor tag) {
		JMenuItem item = getMenuItem();
		item.setText(tag.getName());
		return item;
	}

	protected String defaultInsertion = "<";

	protected void notifySelection(int selection) {
		if (selection >= 1) {
			TagDescriptor td = tags[selection];
			try {
				String element = td.getBuiltTag();
				doc.insertString(offset, element, null);

				if (!td.isRaw()) {
					int i = element.indexOf( "\"" );

					if (i > -1) {
						((XMLPadDocument) doc)
							.getCurrentEditor()
							.setCaretPosition(
							offset + i + 1);
					} else {
						i = element.indexOf("><");
						if (i > -1)
							((XMLPadDocument) doc)
								.getCurrentEditor()
								.setCaretPosition(
								offset + i + 1);
					}
				} else {
					int i = element.indexOf( " " );
					if ( i > -1 ) {
						( (XMLPadDocument) doc )
							.getCurrentEditor()
							.setCaretPosition(
								offset + i + 1 );	
					}
				}

			} catch (BadLocationException exc) {
			}
		} else if (selection == 0) {
			boolean state = ((XMLPadDocument) doc).isSyntaxPopup();
			((XMLPadDocument) doc).setSyntaxPopup(false);
			try {
				doc.insertString(offset, defaultInsertion, null);
			} catch (BadLocationException exc) {
			}
			((XMLPadDocument) doc).setSyntaxPopup(state);
		}
	}
}
