package com.japisoft.xmlpad.look;

import java.awt.Color;

import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.tree.TreeCellRenderer;

import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.editor.XMLEditor;
import com.japisoft.xmlpad.tree.renderer.FastTreeRenderer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XMLPadLook extends MozillaLook {

	public void install( XMLContainer container, JTree tree ) {
		super.install( container, tree );
		TreeCellRenderer renderer = tree.getCellRenderer();
		if ( renderer instanceof FastTreeRenderer ) {
			FastTreeRenderer ftr  =  (FastTreeRenderer)renderer;
			
			if( UIManager.getLookAndFeel().getClass().getName().indexOf( "WindowsLookAndFeel" ) > -1 )
				ftr.setDashUnderlineMode( false );
			else
				ftr.setDashUnderlineMode( true );

			ftr.setDashUnderlineColor( getTreeSelectionBackgroundColor() );
		}
	}

	protected Color getTreeSelectionBackgroundColor() {
		return Color.GRAY;
	}

	public void install( XMLContainer container, XMLEditor editor ) {
		super.install( container, editor );
	}

}
