package com.japisoft.xmlpad.nodeeditor;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditorContext {
	private FPNode node;
	private String text;
	private XMLContainer container;

	/** 
	 * @param node The current edited node
	 * @param text The current edited text equals to the current edited node
	 */	
	public EditorContext( XMLContainer container, FPNode node, String text ) {
		this.node = node;
		this.text = text;
		this.container = container;
	}

	/** @return the current XMLContainer */	
	public XMLContainer getXMLContainer() { 
		return container; 
	}

	/** @return the current edited node */
	public FPNode getEditedNode() { 
		return node;
	}

	/** @return the current edited text */
	public String getEditedText() {
		return text;
	}

	private String result;

	/** Set the editing result. <code>null</code> means there's no
	 * editing changes
	 * @param result
	 */	
	public void setResult( String result ) {
		this.result = result;
	}

	/** @return the current editing result */
	public String getResult() {
		return result;
	}
}
