package com.japisoft.xmlpad.nodeeditor;

import java.util.ArrayList;

import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public final class EditorModel {
	static ArrayList model;

	public static Editor DEFAULT_EDITOR = null;

	static {
		addEditor( DEFAULT_EDITOR = new DefaultEditor() );
	}

	/** Add an editor. The last added has always a priority to the older
	 * added when finding a good editor */	
	public static void addEditor( Editor editor ) {
		if ( model == null )
			model = new ArrayList();
		model.add( editor );
	}

	/** Remove an editor */
	public static void removeEditor( Editor editor ) {
		if ( model == null )
			return;
		model.remove( editor );		
	}

	/** @return an editor for this node. <code>null</code> is returned if
	 * no editor is available.
	 */
	public static Editor getEditorForNode( FPNode node ) {
		if ( model == null )
			return null;
		for ( int i = model.size() - 1; i >= 0; i-- ) {
			if ( ( ( Editor )model.get( i ) ).accept( node ) ) {
				return ( Editor )model.get( i );
			}
		}
		return null;
	}

	/** @return <code>true</code> if the node can be edited */
	public static boolean accept( FPNode node ) {
		if ( model == null )
			return false;
		for ( int i = model.size() - 1; i >= 0; i-- ) {
			Editor e = ( Editor )model.get( i );
			if ( e.accept( node ) )
				return true;
		}
		return false;
	}
}
