package com.japisoft.xmlpad.tree.action;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.action.ActionModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CommentNode extends AbstractTreeAction {
	
	public static final String ID = CommentNode.class.getName();
	
	public CommentNode() {
		super();
	}
	
	public boolean notifyAction() {
		ActionModel.activeActionByName( SelectNode.class.getName() );
		
		SwingUtilities.invokeLater(
				new Runnable() {

					public void run() {
					
						String content = container.getUIAccessibility().getEditor().getSelectedText();
						
						if ( content.indexOf( "<!--" ) > -1 ) {
							JOptionPane.showMessageDialog( container.getView(), 
									XMLContainer.getLocalizedMessage( "COMMENT_ERROR", "Can't comment this node, you must remove the inner comments" ),
									XMLContainer.getLocalizedMessage( "ERROR", "Error" ),
									JOptionPane.ERROR_MESSAGE );
							container.getUIAccessibility().getEditor().select( 
									container.getCaretPosition(),
									container.getCaretPosition() );
			
				
						} else
							container.getUIAccessibility().getEditor().replaceSelection(
									"<!--" + content + "-->" );
						
						}
		
		} );
		
		return true;
	}
	
}
