package com.japisoft.xmlpad.tree.action;

import javax.swing.tree.TreePath;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.nodeeditor.EditorModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditNode extends AbstractTreeAction {

	public static final String ID = EditNode.class.getName();

	public EditNode() {
		super();
	}

	protected void notifyXMLContainer() {
		if ( container.getTree() != null ) {
			TreePath tp = container.getTree().getSelectionPath();
			if ( tp != null )
				setEnabled( EditorModel.accept( ( FPNode )tp.getLastPathComponent() ) );
		}
	}

	protected void actionForSelection( TreePath tp ) {
		container.editNode( ( FPNode )tp.getLastPathComponent() );
	}

	public String getDefaultLabel() {
		return "Edit node";
	}

}
