package com.japisoft.xmlpad.tree.parser;

import com.japisoft.framework.xml.parser.ErrorParsingListener;
import com.japisoft.xmlpad.error.ErrorManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ParsingErrorListener implements ErrorParsingListener {
	private ErrorManager manager;
		
	/** We need to inform all the other components for any parsing problems */
	ParsingErrorListener( ErrorManager manager ) {
		this.manager = manager;
	}
	public void dispose() { 
		manager = null; 
	}
	// Fire an error while a parsing problem
	public void parsingError(
			String message, 
			int offset, 
			int line, 
			int column ) {
		manager.notifyError(
				ErrorManager.ON_THE_FLY_PARSING_CONTEXT,
				true,
				null, 
				line - 1,
				column,
				offset,
				message,
				true );
	}
}
