package com.japisoft.xmlpad.tree.renderer;

import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.tree.renderer.FastTreeRenderer.TreeLabel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DefaultRenderer implements NodeRenderer {
	private static final String TEXT = "text";
	protected ImageIcon i1,i2;
	protected TreeLabel tl;

	public DefaultRenderer(
			ImageIcon i1,
			ImageIcon i2,
			TreeLabel tl ) {
		this.i1 = i1;
		this.i2 = i2;
		this.tl = tl;
	}

	private Map attributes = null;

	public void setAttribute( 
			String nodeName, 
			String attributeName ) {
		if ( attributes == null ) {
			attributes = new HashMap();
		}
		if ( attributeName != null && 
				!"".equals( attributeName ) ) {
			attributes.put( 
				nodeName, 
				attributeName 
			);
		} else {
			attributes.remove( nodeName );
			if ( attributes.size() == 0 )
				attributes = null;
		}
	}

	public void prepare(
			FPNode n, 
			boolean selected ) {
		if ( n.isTag() ) {
			ImageIcon i = i1;
			String sub_content = null;
			if ( attributes != null ) {
				sub_content = 
					( String )attributes.get( 
						n.getNodeContent() );
				if ( sub_content != null )
					sub_content = n.getAttribute( sub_content );
			}
			if ( sub_content == null )
				sub_content = n.getFirstAttributeValue();
			if ( n.childCount() > 0 )
				tl.setContent( n + " (" + n.childCount() + ")",
						sub_content, selected, i);
			else
				tl.setContent( n + " ", sub_content, selected, i);
		} else
			tl.setContent( TEXT, n.getContent(), selected, i2);
	}

}
