// (c) ALEXANDRE BRILLANT : http://www.japisoft.com
// All this work is confidential, you have rights to
// change and evolve it for your products but you
// have no rights to sell it, propose concurrent works.
// Morever any changes to bugs or evolutions should
// be send to JAPISOFT that needs to maintain a
// valid version and has all rights on the product.


package com.japisoft.xpath.function.basic;

import com.japisoft.xpath.function.Lib;
import com.japisoft.xpath.function.Function;
import com.japisoft.xpath.XPathContext;
import com.japisoft.xpath.FastVector;
import java.util.Hashtable;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public final class FunctionLib extends Hashtable implements Lib {

    public FunctionLib() {
	super();
	put( "last", Last.class );
	put( "position", Position.class );
	put( "count", Count.class );
	put( "id", Id.class );
	put( "local-name", LocalName.class );
	put( "namespace-uri", NamespaceURI.class );
	put( "name", Name.class );
	put( "string", String.class );
	put( "concat", Concat.class );
	put( "starts-with", StartsWith.class );
	put( "contains", Contains.class );
	put( "substring-before", SubStringBefore.class );
	put( "substring-after", SubStringAfter.class );
	put( "substring", SubString.class );
	put( "string-length", StringLength.class );
	put( "normalize-space", NormalizeSpace.class );
	put( "translate", Translate.class );
	put( "boolean", Boolean.class );
	put( "not", Not.class );
	put( "true", True.class );
	put( "false", False.class );
	put( "lang", Lang.class );
	put( "number", Number.class );
	put( "sum", Sum.class );
	put( "floor", Floor.class );
	put( "ceiling", Ceiling.class );
	put( "round", Round.class );
    }

    private Hashtable htResolved = null;

    /**
     * Eval the function by its name. If the function is
     * unknown a runtime exception is thrown.
     *
     * @param function a <code>String</code> value
     * @param context a <code>XPathContext</code> value
     * @param arg a <code>Vector</code> value
     * @return an <code>Object</code> value
     */
    public Object eval( java.lang.String function, XPathContext context, FastVector arg ) {
	if ( htResolved == null )
	    htResolved = new Hashtable();
	Function f = ( Function )htResolved.get( function );
	if ( f == null ) {
	    Class c = ( Class )get( function );
	    if ( c == null )
		throw new RuntimeException( "Unknown function " + function );
	    try {
		f = ( Function )c.newInstance();
		htResolved.put( function, f );
	    } catch( Throwable th ) {
		throw new RuntimeException( "Can't use " + function );
	    }
	}
	return f.eval( context, arg );
    }

}

// FunctionLib ends here
