// (c) ALEXANDRE BRILLANT : http://www.japisoft.com
// All this work is confidential, you have rights to
// change and evolve it for your products but you
// have no rights to sell it, propose concurrent works.
// Morever any changes to bugs or evolutions should
// be send to JAPISOFT that needs to maintain a
// valid version and has all rights on the product.


package com.japisoft.xpath.function.basic;

import com.japisoft.xpath.function.*;
import com.japisoft.xpath.XPathContext;
import com.japisoft.xpath.NodeSet;
import com.japisoft.xpath.FastVector;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public final class Number extends AbstractFunction {
    public Number() {
	super();
    }

    public Object eval( XPathContext context, FastVector arg ) {
	java.lang.String s = null;
	if ( arg.size() == 0 ) {
          s = context.getStringValue( context.getNodeFromContext() );
        } else {
          Object o = arg.elementAt( 0 );
          if ( o instanceof java.lang.Boolean ) {
            java.lang.Boolean b = (java.lang.Boolean) o;
            if (b.booleanValue())
              return new Double(1);
            else
              return new Double(0);
          } else
            if ( o instanceof Double )
              return o;
            else
              if ( o instanceof NodeSet ) {
                NodeSet ns = (NodeSet)o;
                return context.convertNodeSetToDouble( ns );
              } else
                if ( o instanceof java.lang.String ) {
                  s = ( java.lang.String )o;
                }
        }
        try {
          if ( s != null )
            return new Double(s);
          else
            return new Double( Double.NaN );
        } catch( NumberFormatException exc ) {
          return new Double( Double.NaN );
        }
    }

}

// Contains ends here
