// (c) ALEXANDRE BRILLANT : http://www.japisoft.com
// All this work is confidential, you have rights to
// change and evolve it for your products but you
// have no rights to sell it, propose concurrent works.
// Morever any changes to bugs or evolutions should
// be send to JAPISOFT that needs to maintain a
// valid version and has all rights on the product.


package com.japisoft.xpath.node;

import com.japisoft.xpath.*;
import com.japisoft.xpath.function.Lib;
import com.japisoft.xpath.FastVector;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Function extends Expr {
    public Function() {
	super();
    }

    public String functionName;

    public void setName( String functionName ) {
	this.functionName = functionName;
    }

    public String getName() {
	return functionName;
    }

    public Object eval( XPathContext context ) {
	// Eval every parameter
	FastVector arg = new FastVector();
	// Save the current NodeSet and location
	int l = context.getContextPosition();
	NodeSet ns = context.getContextNodeSet();

	for ( int i = 0; i < getNodeCount(); i++ ) {
	    AbstractNode n = ( AbstractNode )getNodeAt( i );

	    if ( i > 0 ) {
		context.setContextNodeSet( ns );
		context.setContextPosition( l );
	    }

	    arg.addElement( n.eval( context ) );
	}

	// Reset the context
	if ( getNodeCount() > 0 ) {
	    context.setContextNodeSet( ns );
	    context.setContextPosition( l );
	}

	Lib lib = context.getLibrary();
	return lib.eval( getName(), context, arg );
    }

}

// Function ends here
